sub SrcInstallM {
	my $OO = shift;
	my $count = $OO->{'COUNT'} || 0;	
	delete $OO->{'COUNT'};
	
	info(0,"Ordering source installs for $count packages: ",
	join (' ',sort keys %$OO)) if ($count > 1);

	foreach my $sv (keys %$OO) {
		my $o = $OO->{$sv};
		if (($count == 1) && !$o->{'opts'}->{'simulate'}){
			$o->{'test'} = 0;
			info(0,"Building $o->{S} ($o->{V}) $o->{'prio'}");
			singleSI($o);
			return;
		}
		$o->{'BD'} = aptGetBD($o);
		$o = recurseBD($o);
		my $prio = $PRIO{'extra'};
		foreach my $pkg (keys %{$o->{'binary'}}){
			my $tmp = P_getPrio($pkg,P_verDefault($pkg));
			$prio = $tmp if ($tmp > $prio);
		}
		$o->{'prio'} += $prio;
			
		foreach my $r (@{$o->{'R'}}) {
#			print "R $r->{'S'} $r->{'V'}\n";
			my $SV = "$r->{'S'}=$r->{'V'}";
			my $vV = "$r->{'S'}=$r->{'v'}";
			my $DV = "$r->{'S'}=".S_verSelect($r->{'S'},'default');
			my $NV = "$r->{'S'}=".S_verSelect($r->{'S'},'newest');
			foreach my $key ($SV,$DV,$vV,$NV){
				if ($OO->{$key}){
		#			print "KEY $key\n";
					$OO->{$key}->{'prio'}+= 2*($r->{'prio'});
				}
			}
		}

	}
	undef ($BUILT);
	my @queue;
	foreach my $sv (
	sort { $OO->{$b}->{'prio'} <=> $OO->{$a}->{'prio'} } keys %$OO) {
		my $o = $OO->{$sv};
		$o->{'test'} = 0;
		$o->{'BD'} = undef;
		info(0,"Building $o->{S} ($o->{V}) $o->{'prio'}");
		push (@queue, $o) unless $o->{'opts'}->{'simulate'};
	}
	foreach my $o (@queue) { singleSI($o) }
}

# the constructor...
sub mkSIObj {
	my ($p,$v,@pkg) = @_;
	EXIT("mkSIObj($p,$v,@pkg)") unless ($p && $v);
	my $o;
	$o->{'S'} = $p;
	$o->{'V'} = $v; # this can change
	lvchomp($o->{'v'} = $v); # this NEVER changes
	$o->{'date'} = time; # this never changes, either
	if (@pkg) { %{$o->{'pkgs'}} = map {$_ => 1} @pkg; }
	$o->{'prefix'} = namePrefix($p);
	$o->{'sdir'} = "$BUILDDIR/$o->{'prefix'}/$p";
	($o->{'ep'},$o->{'ups'},$o->{'deb'}) = splitVer($v);
	$o->{'ddir'} = $o->{'sdir'}.'/'.$o->{'S'}.'-'.$o->{'ups'};
	$o->{'diffa'} = $o->{'ddir'}.'.orig';
	$o->{'diffb'} = $o->{'ddir'}.'.new';
	@{$o->{'patches'}} = ();
	@{$o->{'run'}} = ();
	%{$o->{'prompt'}} = %prompt;
	%{$o->{'opts'}} = %opts;
	%{$o->{'var'}} = %ENV;
	%{$o->{'ENV'}} = %ENV;
	%{$o->{'binary'}} = ();
	$o->{'test'} = 0;
	$o->{'prio'} = 0;
	$o->{'BUILD_CMD'} = $BUILD_CMD;
	$o->{'BINARY_CMD'} = $BINARY_CMD;
	return $o;
}

sub singleSI {
	my $o = shift;
	lvchomp($o->{'V'});
	$o->{'test'} = 0;	
	%ENV = %{$o->{'ENV'}};
	if (!(-r "$o->{'ddir'}/debian/changelog") || $opts{'overwrite'}) {
		aptGetS_X($o->{'S'},$o->{'V'});
	}

	chdir $o->{'sdir'} or EXIT("$! chdir $o->{'sdir'} (singleSI)");
	
	my ($s,$v) = readChangelog("$o->{'ddir'}/debian/changelog");
	lvchomp($v);
	aptGetS_X($o->{'S'},$o->{'v'}) if ($v ne $o->{'v'});
	
	chdir $o->{'ddir'} or EXIT("$! chdir $o->{'ddir'} (singleSI)");

	$o = changelogMod($o) if ($o->{'opts'}->{'change-version'});
	($o->{'S'},$o->{'V'}) = readChangelog('debian/changelog');
	
	info(0,"To build: [$o->{'S'}] version: $o->{'V'}");

	if ($o->{'opts'}->{'modify'}){
		&archSync;
		$o = applyCustom($o) 
	}
	&archSync;

	if ($o->{'opts'}->{'ignore-build-deps'}) {
		wLog("Build dependencies ignored for $o->{'S'} ($o->{'V'})");
	} else {
		info(0,"Retrieving build dependencies $o->{'S'} ($o->{'V'})...");
		$o = singleBD($o);
		
		unless ($o->{'opts'}->{'recursive'} || $o->{'opts'}->{'source-only'}){
			$o->{'R'} = undef;
		}

		
		foreach my $oo (@{$o->{'R'}}){
			iLog("RECURSIVE BUILD $oo->{'S'}");
		}

		foreach my $oo (@{$o->{'R'}}){
			$oo->{'STATE'} = DUMP();
			# always reinstall something if it's a build-dependency
			delete $oo->{'opts'}->{'no-install'};
			singleSI($oo);
		}
	}

	#foreach my $i (keys %{$o->{'pkgs'}}) { print "PKGS 111111 $i\n"; }

	info(0,"Building source package: $o->{'S'} ($o->{'V'}) ...");
	$o = buildPkg($o);
	
	#foreach my $i (keys %{$o->{'pkgs'}}) { print "PKGS 222222 $i\n"; }
	
	info(0,"Done building source package: $o->{'S'} ($o->{'V'})"); 
	
	&GEN_PKGLIST2;
	
	return if ($o->{'opts'}->{'no-install'} && !$o->{'opts'}->{'upgrade'});
	
	policy2CacheM($o->{'binary'});
	my $in;
	foreach my $b (keys %{$o->{'binary'}}) {
		infon(0,"Was package: $b installed? ");
		if (($IMCACHE->{$b} && ($IMCACHE->{$b}=~/install ok installed/))
		||($o->{'opts'}->{'keep-builddeps'} && isInstalled($b) == 0)){
			$in->{"$b=$o->{'binary'}->{$b}"} = 0;
			info(0,"YES");
		} else {
			info(0," NO");
		}
	}
	unless($o->{'opts'}->{'no-install'}){
		foreach my $i (keys %{$o->{'pkgs'}}) {
			next unless ($i);
			next if ($in->{$i});
			if ($i =~/([^\=]+)\=([^\=]+)/) {
				my ($p,$v) = ($1,$2);
				lvchomp(my $vv = $o->{'binary'}->{$p});
				lvchomp(my $sv = $v);
				if ($o->{'binary'}->{$p} && (
				($o->{'binary'}->{$p} eq $v)||($v eq $vv)||($vv eq $sv)
				)){
					#$in->{"$p=$o->{'binary'}->{$p}"} = 0,
					$in->{"$p=$vv"} = 0,
				}
			} elsif (defined $o->{'binary'}->{$i}) {
				if (P_verDefault($i) ne ($o->{'binary'}->{$i})){
					$in->{$i} = 0;
				} else {
					$in->{"$i=$o->{'binary'}->{$i}"} = 0;
				}
			}
		}
	}

	if ($o->{'STATE'}) {
		aptGetIR_nl('INSTALL',keys %$in);
		RESTORE($o->{'STATE'},1);
	} else {
		aptGetIR('INSTALL',keys %$in);
	}
	closeAptPkgCache();
	iLog("COMPLETED source install: $o->{'S'} ($o->{'V'}) [ ",
	join(' ',keys(%$in))," ]");
}

# buildPkg - this function assumes that build-deps have been properly installed
# already.  
sub buildPkg {
	our ($o,$debdir,$src,$ver);
	$o = shift;
	return $o if $o->{'opts'}->{'simulate'};
	
	my $prefix = $o->{'prefix'};
	my $date = (defined $o->{'date'}) ? $o->{'date'} : time;
	$date = myDate($date);
	
	if (defined $BUILT->{"$o->{'S'}=$o->{'V'}"}){
		%{$o->{'binary'}} = %{$BUILT->{"$o->{'S'}=$o->{'V'}"}};
		iLog("$o->{'S'} ($o->{'V'}) already built, skipping");
		return $o;
	} elsif (defined $BUILT->{"$o->{'S'}=$o->{'v'}"}){
		%{$o->{'binary'}} = %{$BUILT->{"$o->{'S'}=$o->{'v'}"}};
		iLog("$o->{'S'} ($o->{'V'}/$o->{'v'}) already built, skipping");
		return $o;
	}
	($src,$ver) = ($o->{'S'},$o->{'V'});
	my $sdir = $o->{'sdir'};
	my @ss = stat($sdir);
	unless (-d $o->{'ddir'}&& -x "$o->{'ddir'}/debian/rules" ) {
		warn("buildPkg called w/o existing build-dir, creating...\n");
		aptGetS_X($o->{'S'},$o->{'V'});
	}
	unless ($ROOTX){
		# some archives extract with funny permissions when root
		sys("chown --recursive $ss[4]:$ss[5] $o->{'ddir'}");
	}
	$debdir = "$sdir/DEB/$date";
	closeAptPkgCache();
	
	if ( chdir $o->{'ddir'} ){
		my $binfo = "$debdir/build-info.log";
		sys("mkdir -m 0755 -p $debdir") unless (-d $debdir);
		tmpLink("$TMPDIR/$$.current-info.log",$binfo);
		
		open BINFO, "> $binfo" or EXIT("$! open >$binfo\n");
		my $start = time;
		print BINFO "# APT-Fu ($VERSION) build-info log: $binfo\n";
		print BINFO "# Do not modify or remove the original file, ",
		"copy it to a new name/location to make an opt file\n";
		print BINFO "# uname -a: ",`uname -a`;
		print BINFO "SRC $o->{'S'} (= $o->{'V'})\n";
		print BINFO 'START ', `uptime`;
	
		print BINFO "INC $_\n" foreach (reverse @{$o->{'run'}});
		print BINFO "P $_\n" foreach (@{$o->{'patches'}});
		print BINFO "STATE $LASTDUMP\n" if ($LASTDUMP) ;
		print BINFO "OPT $_ $o->{'opts'}->{$_}\n" foreach (sort keys %{$o->{'opts'}});
		
		foreach my $T (sort keys %{$o->{'BD'}}){
			foreach my $d (sort keys %{$o->{'BD'}->{$T}}){
				print BINFO "$T $d\n";
			}
		}
		
		foreach my $g (sort keys %{$o->{'static'}}){
			print BINFO "R $g $o->{'static'}->{$g}\n" 
		}

		foreach (sort keys %ENV) {
			print BINFO "ENV $_=$ENV{$_}\n" unless($ENV{$_}=~/\n/);
		}
	
		if ($o->{'opts'}->{'always-clean'}) {
			if ($ROOTX && (!-x $FAKER) 
			&& !$o->{'opts'}->{'source-only'}){
				aptGetIR_nl('install','fakeroot');
			}
			sys("$FAKER debian/rules clean");
		}
		
		if ($o->{'BINARY_CMD'}=~/\Q$FAKER\E/ && !(-x $FAKER)
		&& !$o->{'opts'}->{'source-only'}){
			aptGetIR_nl('install','fakeroot');
		}
		
		foreach (<$sdir/*.deb>){ unlink $_ }
		
		$| = 1;	
		my $oldmask = umask 0022;
		&rulesBuild if ($o->{'BUILD_CMD'}=~/\S/);
		# some archives extract with funny permissions when root
		if (-r 'debian/POSTBUILD.opt') {
			unshift @{$o->{'run'}}, 'debian/POSTBUILD.opt';
			$o = optRun($o);
		}
		closeAptPkgCache();
		&rulesBinary if ($o->{'BINARY_CMD'} =~/\S/);
		umask $oldmask;
		$| = 0;	
		my $elapsed = time - $start;
		print BINFO 'END ',`uptime`;
		print BINFO "ELAPSED $elapsed seconds\n";
		close BINFO;
		
		unlink "$TMPDIR/$$.current-info.log";
		compress($binfo);
	} else {
		EXIT("$! chdir $o->{'ddir'}");
	}	

	chdir $sdir or EXIT("$! chdir $sdir (buildPkg)");
	
	fixDepVersions(<$sdir/*.deb>) if ($o->{'opts'}->{'relax-depends'});
	sys("mv $sdir/*.deb $debdir")== 0||wLog("$!: mv $sdir/*.deb $debdir\n");
	$o->{'binary'} = SCAN(<$debdir/*.deb>);
	
	%{$BUILT->{"$o->{'S'}=$o->{'V'}"}} = %{$o->{'binary'}};
	%{$BUILT->{"$o->{'S'}=$o->{'v'}"}} = %{$o->{'binary'}};
	
	unlink "$sdir/DEB/latest" if (-l "$sdir/DEB/latest");
	
	if (-e "$sdir/DEB/latest") {
		wLog("$sdir/DEB/latest exists and is not a symlink! moved to",
		": $sdir/moved.$$.$date");
		sys("mv $sdir/DEB/latest $sdir/moved.$$.$date") == 0 
		|| EXIT("mv $sdir/DEB/latest $sdir/moved.$$.$date");
	}

	chdir "$sdir/DEB" || EXIT("$! chdir $sdir/DEB");
	
	symlink (basename($debdir),"latest") 
	|| EXIT("$!: symlink $debdir latest");
	
	chdir $sdir or EXIT("$! chdir $sdir (buildPkg)\n");
	
	my $pf = $o->{'prefix'};
	
	sys("mkdir -m 0755 -p $MYCACHE/$pf")==0
	||EXIT("$! mkdir -p $MYCACHE/$pf");
	
	unlink "$MYCACHE/$pf/$src" if (-l "$MYCACHE/$pf/$src");
	
	if (-e "$MYCACHE/$pf/$src") {
		wLog("$MYCACHE/$pf/$src exists and is not a symlink! moved to",
		"hidden file: $MYCACHE/$pf/.$$.$date.$src");
		
		sys("mv $MYCACHE/$pf/$src $MYCACHE/$pf/.$$.$date.$src") == 0 
		||EXIT("$!:mv $MYCACHE/$pf/$src $MYCACHE/$pf/.$$.$date.$src");
	}
	
	chdir "$MYCACHE/$pf" || EXIT("$! chdir $MYCACHE/$pf");
	symlink "$sdir/DEB/latest",$src
	|| EXIT("$! symlink $sdir/DEB/latest $src\n");
	chdir $sdir or EXIT("$! chdir $sdir (buildPkg)\n");
	
#	if ($o->{'opts'}->{'autopurge'}) {
#		PURGESD($o->{'sdir'}) if (-d $o->{'sdir'});
#	} els
	if ($o->{'opts'}->{'autoclean'}) {
		CLEANSD($o->{'ddir'}) if (-d $o->{'ddir'});
	}
	
	if ($o->{'opts'}->{'autoclean'}||$o->{'opts'}->{'autopurge'}) {
		CLEANDEBS($o->{'sdir'});
	}
	
	return $o;

	sub tmpLink {
		my ($tmp,$tlog) = @_;
		unlink $tmp if (-l $tmp);
		symlink($tlog, $tmp);
	}

	sub rulesBuild {
		my $build = "$debdir/build.log";
		tmpLink("$TMPDIR/$$.current-build.log",$build);
		open LOG, "> $build"||EXIT("$!: Unable to open build log");
		
		print LOG "# APT-Fu ($VERSION) log output of ",
		"\`$o->{'BUILD_CMD'}\`: $build\n";
		
		info(-1,"Compiling and building $src ($ver)");
		info(-1,"Output of $o->{'BUILD_CMD'} logged to $build");
		my $pid = open (PIPE, "-|");
		if ($pid) {
			my $i = 0;	
			while (<PIPE>) {
				print LOG $_;
				info(0,$_);
				++$i;
				if ($i == $o->{'opts'}->{'sprinkle'}) {
					info(0,"[APT-Fu] \e[4m$o->{'BUILD_CMD'}\e[0m [$src ($ver)]...");
					$i = 0;
				}
			}
			
			close PIPE 
			|| EXIT("$!: $src ($ver) $o->{'BUILD_CMD'}.\n",
			"Log: $build");
		} else {
			exec("$o->{'BUILD_CMD'} 2>&1")
			||EXIT("$!: $src ($ver) $o->{'BUILD_CMD'} 2>&1 |");
		}
		close LOG;
		sys("reset"); # for vim and any packages like it :()
		unlink "$TMPDIR/$$.current-build.log";
		compress($build);
	}
	
	sub rulesBinary {
		my $binary = "$debdir/binary.log";
		tmpLink("$TMPDIR/$$.current-binary.log",$binary);
		open BLOG, "> $binary" ||EXIT("$!: Unable to open binary log");
	
		print BLOG "# APT-Fu ($VERSION) log output of ",
		"\`$o->{'BINARY_CMD'}\`: $binary\n";
		
		info(-1,"Building binary packages for $src ($ver)");
		info(-1,"Output of `$o->{'BINARY_CMD'}` logged to $binary");
		my $pid = open (PIPE,"-|");
		if ($pid){	
			my $i = 0;
			while (<PIPE>) { 
				print BLOG $_;
				info(0,$_);
				++$i;
				if ($i == $o->{'opts'}->{'sprinkle'}) {
					info(0,"[APT-Fu] \e[4m$o->{'BINARY_CMD'}\e[0m [$src ($ver)]...");
					$i = 0;
				}
			}
			
			close PIPE 
			||EXIT("$!: $src ($ver) $o->{'BINARY_CMD'}\n",
			"Log $binary");
		} else {
			exec("$o->{'BINARY_CMD'} 2>&1")
			||EXIT("$!: $src ($ver) $o->{'BINARY_CMD'} 2>&1 |");
		}
		close BLOG;
		sys("reset"); # for vim and any packages like it :()
		unlink "$TMPDIR/$$.current-binary.log";
		compress($binary);
	}
}

1;
