
sub singleBD {
	my $o = shift;
	$o->{'BD'} = undef;
	$o->{'BD'} = aptGetBD($o);

	$LASTDUMP= &DUMP unless (defined $LASTDUMP);

	if ($o->{'opts'}->{'source-only'}){
		wLog("APT::Fu:SourceOnly enabled for $o->{'S'} ($o->{'V'}).  ",
		"Please report or fix circular build-dependency bugs");
	} else {
		aptGetIR_nl('remove',keys(%{$o->{'BD'}->{'BC'}}),
		keys(%{$o->{'BD'}->{'BCI'}}));

		aptGetIR_nl('install',keys(%{$o->{'BD'}->{'BE'}}),
		keys(%{$o->{'BD'}->{'BD'}}),keys(%{$o->{'BD'}->{'BDI'}}));
	}
	
	$o = recurseBD($o);
	
	# for --source-only users, if they have local verisons
	aptGetIR_nl('install',@{$o->{'LVI'}}),	
	
	return $o;
}

# this is for multiple source packages
# this will expose conflicting build-dependencies that would otherwise 
# get ignored by `apt-get build-dep`

# this returns a hashref with build-dependency types, including one
# of all the build-essential packages and their install dependencies

sub buildEssential {
	return $BUILDESSENTIAL if (defined $BUILDESSENTIAL);
	foreach my $pkg($_config->get('APT::Build-Essential','build-essential'),
	$_config->get('APT::Build-Essential::','build-essential') ){
		if ($pkg){
			$pkg = resolveDep($pkg,0);
			$BUILDESSENTIAL->{$pkg} = 0;
		}
	}
	$BUILDESSENTIAL = testDepTree($BUILDESSENTIAL);

	foreach my $be (keys %$BUILDESSENTIAL) { $BUILDESSENTIAL->{$be} **= 2; }
	return $BUILDESSENTIAL; 
}

sub SIObins {
	my $o = shift;
	unless (keys %{$o->{'binary'}}) {
		my $ver = $o->{'V'};
		lvchomp($ver);
		$o->{'binary'} = S_getPkgField($o->{'S'},$ver,'Binary');
		policy2CacheM($o->{'binary'});
#		foreach my $bin (keys %{$o->{'binary'}}){
#			$o->{'binary'}->{$bin}= $o->{'V'};## just pl;a
#			#$o->{'binary'}->{$bin}= P_verDefault($bin);
#		}
	}
	return $o;
}

# only gets install build dependencies, not build-deps of build-deps
sub aptGetBD {
	my $o = shift;
	my ($src,$ver) = ($o->{'S'},$o->{'V'});
	
	my $ctrl = "$o->{'ddir'}/debian/control";
	
	my $BD;
	if (-r $ctrl) { # use the debian/control for the src pkg
		info(5,"Using $ctrl");
		($BD->{'BD'},$BD->{'BC'},$BD->{'BDI'},$BD->{'BCI'}) 
			= aptGetBD_ctrl($ctrl);
	} else {
#		print STDERR 
#		"$ctrl not found. Using \`$APTCACHE showsrc $o->{'S'}\`\n";
		
		($BD->{'BD'},$BD->{'BC'},$BD->{'BDI'},$BD->{'BCI'}) 
			= aptGetBD_cache($src,$ver);
	}
	return resolveBD($BD);
}

sub resolveBD {
	my $BD = shift;
	my $ret;
	$ret->{'BE'} = buildEssential();
	foreach my $T (sort keys %$BD) {
		mchomp($BD->{$T});
		unless ($BD->{$T}) {
			delete $BD->{$T};
			next;
		}
		%{$ret->{$T}} = map{$_ => 1} split(/\s*,\s*/,$BD->{$T});
		my $V = ($T =~/C/ ) ? 1 : 0;
		if ($V) {
			$ret->{$T} = revDepTree($ret->{$T});
		} else {	
			$ret->{$T} = testDepTree($ret->{$T});
		}
	}

	uniqBD($ret);
	return $ret;
	
	# delete multiple occurences of the same entry
	sub uniqBD {
		foreach my $i (keys %{$_[0]->{'BE'}}){
			if (defined $_[0]->{'BD'}->{$i}){
				$_[0]->{'BE'}->{$i} += $_[0]->{'BD'}->{$i};
				delete $_[0]->{'BD'}->{$i};
			}
			if (defined $_[0]->{'BDI'}->{$i}){
				$_[0]->{'BE'}->{$i} += $_[0]->{'BDI'}->{$i};
				delete $_[0]->{'BDI'}->{$i};
			}
		}
		foreach my $i (keys %{$_[0]->{'BDI'}}){
			if (defined $_[0]->{'BD'}->{$i}){
				delete $_[0]->{'BD'}->{$i};
			}
		}
	}
}

# install binary versions of build-deps first, *then* scan
# for static libraries in installed files (using apt-file to get
# Contents info on the web is just as slow), probably only viable for stable
# since it doesn't change often

# trying to decide what gets built and the order it's done in for best
# results is just a simple chicken and egg problem :(
sub recurseBD {
	my $o = shift;
	$o->{'R'} = undef;
	$o->{'static'} = undef;
	info(-1,"Picking dependencies which may be rebuilt for $o->{'S'} ($o->{'V'})");
#		print "GETTING TOP LEVEL DEPS\n";
	$o = SIObins($o);
	unless ($o->{'ID'}){
		foreach my $bin ( keys %{$o->{'binary'}}){
			if ($IMCACHE->{$bin} && 
			($IMCACHE->{$bin} =~/install\s+ok\s+installed/)){
				$o->{'pkgs'}->{$bin} = 1 
			}
		}
		$o->{'pkgs'} = TopLvlDeps($o->{'pkgs'});
		$o->{'ID'} = 1;
	}
	my $SI = worthBuilding($o);
	show2CacheM($SI);
	showsrc2CacheM($SI);
	# calculate priorities for build-dependencies
	# not completely accurate, but better than no ordering at all
	foreach my $si (keys(%$SI)) {
		my ($p,$v) = split(/=/,$si);

		my ($src,$ver) = S_verSelect($p,$v);
		lvchomp($ver);
		if ($o->{'test'} == 0){
#		#mark stuff to avoid infinite looping when
#		#actually doing the source builds
			lvchomp(my $fv = $v);
			if (($o->{'S'} eq $src) || $o->{'pkgs'}->{"$src=$ver"}
			|| $o->{'pkgs'}->{$src} || $o->{'pkgs'}->{$p}
			|| $o->{'pkgs'}->{"$p=$v"}|| $o->{'pkgs'}->{"$p=$fv"}){
#				iLog("REJECTED: $si");
				next;
			}
			
			$o->{'pkgs'}->{"$src=$ver"} = 1;
			$o->{'pkgs'}->{"$p=$v"} = 1;
		}
		
		my $bonus = $SI->{$si} || 0;
		my $prio = $SCACHE->{$src}->{$ver}->{'Priority'} || 'extra';
		my $priop = P_getPrio($p,$v);
		my $pprio = ($PRIO{$prio}*100) + $priop + $bonus;
		
		$o->{'static'}->{"$p=$v"} = $pprio;
#		iLog("ACCEPTED: $si");
	}

	my $q;
	foreach my $pv (keys(%{$o->{'static'}})) {
		my ($s,$v) = S_verSelect(split(/\=/,$pv));
		next if (exists $q->{"$s=$v"});
		$q->{"$s=$v"} = 1;
#		print "1mkSIObj $s=$v $pv\n";
		next if ($v eq $verDefault);
		my $t = mkSIObj($s,$v);
		my $bb = aptGetBD($t);
		foreach my $T ('BE','BD'){
			foreach my $ff (keys %{$bb->{$T}}){
				if (defined $o->{'static'}->{$ff}){
					$o->{'static'}->{$ff} += $bb->{$T}->{$ff};
				}
			}
		}
	}
	undef $q;
	my $idx;
	
	foreach my $pv (keys(%{$o->{'static'}})) {
		$idx->{$pv} = $o->{'static'}->{$pv};
	}
	
	foreach my $i (sort {$b <=> $a} (values(%$idx))) {
		foreach my $s (keys %{$o->{'static'}}){
			next unless ($o->{'static'}->{$s} == $i);
			
			my ($p,$v)= split(/\=/,$s);
			my $lv = localVer($p);
			my $cv = currentVer($p);
	#		my $dv = P_verDefault($p);
			
		#	$lv = $dv if ($lv eq $verDefault);
			# be nice to simulation runs where BDs aren't on the
			# system
			if ($o->{'opts'}->{'simulate'} || $o->{'test'}){
				$cv = $lv if ($lv ne $verDefault);
			}
			
			if ($o->{'opts'}->{'source-only'}) {
				next if ($cv ne $verDefault);
				if (($lv ne $verDefault) && !$o->{'opts'}->{'rebuild-all'}) {
					push @{$o->{'LVI'}}, $s;
					next;
				}
			} else {
				next if (($lv eq $cv) && ($cv ne $verDefault) &&
				!$o->{'test'} && !$o->{'opts'}->{'rebuild-all'});
			}
			
			# && ($lv ne $v));#(&& $dv eq $lv)
		#	print "$lv = $cv = $v = $dv $s $o->{'opts'}->{'rebuild-all'}\n";

			my ($src,$ver) = S_verSelect($p,$v);
			
			# don't build a source package twice
			next if (exists $q->{"$src=$ver"});
			$q->{"$src=$ver"} = 1;
			
			next if ($ver eq $verDefault);

			my $oo = mkSIObj($src,$ver,keys %{$o->{'pkgs'}});
			$oo->{'prio'} = $i;	
			push @{$o->{'R'}},$oo;
#			next if ($o->{'test'} && !$o->{'opts'}->{'simulate'});
			if ($o->{'opts'}->{'simulate'} &&
			(!exists $BUILT->{$src}
			&& !exists $BUILT->{"$src=$ver"})){
			#	$oo = SIObins($oo);
			#	just placeholders here
				%{$BUILT->{"$src=$ver"}} = %{$oo->{'binary'}};
				%{$BUILT->{$src}} = %{$oo->{'binary'}};
				#iLog(0,"Maybe build: build-deps in $src ($ver) ",
				info(0,"Maybe build: build-deps in $src ($ver) ",
				"prio: $i for $p=$v [$o->{'S'} ($o->{'V'})] ",
				"(if --recursive)");
			}
		}
	}
	return $o;
}

sub openStaticLibList {
	my $ret = shift;
	return $ret if (defined $ret);
	return $ret unless (-r $_[0]);
	my $FD = zOpen($_[0]);
	while (<$FD>) {
		next if (/^#/);
		if (/^(\S+)\s+(\d+)\n$/){
			$ret->{$1} = $2;
		}
	}
	close $FD;
	return $ret;
}

# scores (number of static libs/objects) are kept, but not used atm.
sub add2StaticLibList {
	my ($pv,$n) = @_;
	$CONTENTS = openStaticLibList($CONTENTS,$STATIC);
	$CONTENTS->{$pv} = $n;
	lvchomp($v);
	$CONTENTS->{$pv} = $n;
}

sub checkStaticLibList {
	my ($pv) = @_;
	$CONTENTS = openStaticLibList($CONTENTS,$STATIC);
	return 0 if ($CONTENTS->{$pv});
	lvchomp($v);
	return 0 if ($CONTENTS->{$pv});
	return 1;
}

sub writeCONTENTS {
	return unless (defined $CONTENTS);

	open FD, "> $STATIC" ||EXIT("$!: > $STATIC");
	print FD "# List of packages containing static libraries.  Edit at your own risk!\n";
	foreach my $p (sort keys %$CONTENTS){ print FD "$p $CONTENTS->{$p}\n"}
	close FD;
	
}


# flag packages with staticly linked libaries
# so that they're built from source, also find build-deps that
# have the same source package as an install dep;
sub worthBuilding {
	my $o = shift;
	my $ret;
	
	if ($o->{'opts'}->{'source-only'}){
		foreach my $T ('BE','BD','BDI') {
			foreach my $i (keys %{$o->{'BD'}->{$T}}) {
				$ret->{$i} = $o->{'BD'}->{$T}->{$i};
			}
		}
		return $ret;
	}
	
	$| = 1;
	foreach my $T ('BE','BD') {
		foreach my $i (keys %{$o->{'BD'}->{$T}}){
			my ($p,$v) = split /\=/,$i;
			next if (P_archIndep2($p,$v) == 0);
			my ($src,$ver) = S_verSelect($p,$v);
			next if (($src eq $o->{'S'}) &&
			(($ver eq $o->{'V'})||( $ver eq $o->{'v'})));
			my $sec = P_getSection($p,$v);
			next unless ($sec =~/lib/ || $sec=~/devel/);
			if ($o->{'test'} == 1){
				infon(0,".");
				$ret->{$i} = $o->{'BD'}->{$T}->{$i};
				next;
			}
			
			if ((checkStaticLibList($i) == 0)
			|| $o->{'pkgs'}->{$i} || $o->{'pkgs'}->{$p} ){
				$ret->{$i} = $o->{'BD'}->{$T}->{$i};
				infon(0,".");
				next;
			}
			my $tmp = S_getPkgField($src,$ver,'Binary');
			foreach my $in (keys %$tmp) {
				# see if a to-be-installed binary shares
				# a source package with the build-dep
				my $vin = P_verDefault($in);
				my $cv = currentVer($in);
				lvchomp(my $lv = $vin);
				if ($o->{'pkgs'}->{$in} || 
				$o->{'pkgs'}->{"$in=$lv"} ||
				$o->{'pkgs'}->{"$in=$vin"} ||
				$o->{'pkgs'}->{"$in=$cv"} ){
					$ret->{$i} = $o->{'BD'}->{$T}->{$i};
					infon(0,".");
					last;
				}
			}
			next if ($ret->{$i});
			next unless (isInstalled($p)==0);
			
			open FH, "$DPKG -L $p |" ||EXIT("$! $DPKG -L $p\n");
			while (<FH>) {
				if (/\.(?:o|a)\n$/) {
					$ret->{$i} = $o->{'BD'}->{$T}->{$i};
					infon(0,".");
					close FH;
					last;
				}
			}
			close FH;
			add2StaticLibList($i,$ret->{$i}) if ($ret->{$i});
		}
	}
	infon(0,"\n");
	$| = 0;
	return $ret;
}

1;
