
$DIR = $_config->get('Dir','/');

my $lconf = $DIR.$_config->get('Dir::Etc','etc/apt').'/apt-fu/apt-fu.conf';

$_config->read_file($lconf,1) if (-r $lconf); 

{
	use filetest 'access';
	if ((-W $DIR) && (-w $DIR)) {
		# root user
		$ROOTX = '';
	} else  {
		# ordinary user (recommended)
		$ROOTX = $_config->get('Dir::Bin::RootCmd','/usr/bin/sudo');
		unless (-x $ROOTX){
			die "sudo is required for non-root use. ",
			"`apt-get install sudo` and read the section on ",
			"setting up sudo in the apt-fu(1) man page.";
		}
	}
}

if ((defined $ENV{'HOME'}) && (-w $ENV{'HOME'}) && (-W $ENV{'HOME'})) {
	$APTFU = $ENV{'HOME'}.'/.apt-fu';
	mkdir $APTFU;
	if (-r "$APTFU/apt-fu.conf") {
		$_config->read_file("$APTFU/apt-fu.conf",1);
	}
} else {
	exit("\$HOME not defined!\n");
}

$DIR = $_config->get('Dir','/');
$FAKER = $_config->get('Dir::Bin::fakeroot','/usr/bin/fakeroot');
$APTGET = $_config->get('Dir::Bin::apt-get','/usr/bin/apt-get');
$APTCACHE = $_config->get('Dir::Bin::apt-cache','/usr/bin/apt-cache');

$RULES_BUILD = 'debian/rules build';
$RULES_BINARY = 'debian/rules binary';
$BUILD_CMD = $RULES_BUILD;
$BINARY_CMD = "$FAKER $RULES_BINARY";


$UPGRADEABLE 
= $DIR.$_config->get('Dir::Etc','etc/apt').'/apt-fu/upgradeable.list';

$CACHEDIR = $DIR.$_config->get('APT::Fu::Repository','var/cache/apt-fu/repository');
$MYCACHE = $CACHEDIR; 

$BUILDDIR = $DIR.$_config->get('APT::Fu::Sources','usr/src/apt-fu/sources');
$LOGDIR = $DIR.$_config->get('APT::Fu::log','var/log/apt-fu');
$TMPDIR = $DIR.$_config->get('APT::Fu::tmp','var/run/apt-fu');
$STATIC = $DIR.$_config->get('APT::Fu::static','var/lib/apt-fu/static.list');

$opts{'cli_aptget'} = $_config->get('APT::Fu::AptGetCLOpts','-y');

if ($ROOTX) {
	# running as a regular user
	$MYCACHE = "$APTFU/repository"; 
	$BUILDDIR = "$APTFU/sources";
	$LOGDIR = "$APTFU/log";
	$TMPDIR = "$APTFU/tmp";
	$STATIC = "$APTFU/static.list";
}
	
$CACHEPKGS = "$CACHEDIR/Packages";
$RELEASE = "$CACHEDIR/Release";
$MCACHEPKGS = "$MYCACHE/Packages";
$MRELEASE = "$MYCACHE/Release";

# non-Debian x86 arch hacks
$ENV{'MY_DEBIAN_ARCH'}= 
$_config->get('APT::Fu::LocalArchitecture',$_config->get('APT::Architecture'))
|| $ENV{'MY_DEBIAN_ARCH'};

# should probably be hardcoded.
$ENV{'OPTPATH'} = $ENV{'OPTPATH'} || 
$_config->get('APT::Fu::OptPath',
"/etc/apt/apt-fu:/etc/apt/apt-fu/\@src\@:$APTFU/opt.d:$APTFU/opt.d/\@src\@:$BUILDDIR/\@prefix\@/\@src\@/OPT:$BUILDDIR/\@prefix\@/\@src\@/PATCHES"
);

$ENV{'DEPORDER'} = $ENV{'DEPORDER'}||
$_config->get('APT::Fu:DependencyOrder','current,local,default,newest');

$APTGET .= " $opts{'cli_aptget'}";

if ($ENV{'MY_DEBIAN_ARCH'} ne $XARCH{$ENV{'MY_DEBIAN_ARCH'}}){
	$APTGET .= " -oAPT::Architecture=$XARCH{$ENV{'MY_DEBIAN_ARCH'}}"
	.' -oDPkg::Options::=--force-architecture';
}

$DPKG = $_config->get('Dir::Bin::dpkg','/usr/bin/dpkg');

$DPKGARCH = $_config->get('Dir::Bin::dpkg-architecture',
'/usr/bin/dpkg-architecture');

$IDIFF = $_config->get('Dir::Bin::interdiff','/usr/bin/interdiff');
$DPKGDEB = $_config->get('Dir::Bin::dpkg-deb','/usr/bin/dpkg-deb');
$DPKGSRC = $_config->get('Dir::Bin::dpkg-source','/usr/bin/dpkg-source');
$DCH = $_config->get('Dir::Bin::debchange','/usr/bin/debchange');
$DSCV = $_config->get('Dir::Bin::dscverify','/usr/bin/dscverify');
$DZ = $_config->get('APT::Fu::DefaultCompressor','/bin/gzip');
$STATUS = $_config->get('Dir::State::status','/var/lib/dpkg/status');

$APT_LISTDIR = $DIR.$_config->get('Dir::State','var/lib/apt/').
	$_config->get('Dir::State::lists','lists');

$RDR = ''; #default redirect for system();

# set/unset environment variables
sub archSync {
	if ($ENV{'MY_DEBIAN_ARCH'} ne $XARCH{$ENV{'MY_DEBIAN_ARCH'}}) {
		foreach my $env (`$DPKGARCH`) {
			chomp $env;
			my ($k,$v) = split(/\=/,$env);
			$v =~ s/\Q$XARCH{$ENV{'MY_DEBIAN_ARCH'}}\E
			/\Q$ENV{'MY_DEBIAN_ARCH'}\E/gx;
			$ENV{$k} = $v;
		}
	} else {
		foreach ('DEB_BUILD_ARCH','DEB_BUILD_GNU_CPU',
		'DEB_BUILD_GNU_SYSTEM','DEB_BUILD_GNU_TYPE','DEB_HOST_ARCH',
		'DEB_HOST_GNU_CPU','DEB_HOST_GNU_SYSTEM','DEB_HOST_GNU_TYPE'){
			delete $ENV{$_};
		}
	}
}
&archSync;
# end of non-Debian x86 arch hacks
$opts{'ignore-build-deps'} = $_config->get_bool('APT::Fu::IgnoreBuildDeps',0);
$opts{'relax-depends'} = $_config->get_bool('APT::Fu::RelaxDepends',1);
$opts{'change-version'}= $_config->get_bool('APT::Fu::ChangeVersion',1);
$opts{'modify'} = $_config->get_bool('APT::Fu::ModifySource',1);
$opts{'autodiff'} = $_config->get_bool('APT::Fu::Diff',1);
$opts{'quiet'} = $_config->get('APT::Fu::quiet/i',0); 
$opts{'verbose'} = $_config->get('APT::Fu::verbose/i',0);
$opts{'dbg'} = $_config->get('APT::Fu::DebugMask',0);
$opts{'simulate'} = $_config->get_bool('APT::Fu::Simulate',0);
$opts{'prompt'} = $_config->get('APT::Fu::Prompt','');
$opts{'filename'} = $_config->get('filename','');
$opts{'field'} = $_config->get('field','');
$opts{'overwrite'} = $_config->get_bool('APT::Fu::Overwrite',0);
$opts{'recursive'} = $_config->get_bool('APT::Fu::Recursive',0);
$opts{'autoclean'} = $_config->get_bool('APT::Fu::Clean',0);
$opts{'autopurge'} = $_config->get_bool('APT::Fu::Purge',0);
$opts{'keep-builddeps'} = $_config->get_bool('APT::Fu::KeepBuildDeps',0);
$opts{'always-clean'} = $_config->get('APT::Fu::AlwaysClean',0);
$opts{'cc-override'} = $_config->get('APT::Fu::CompilerOverride',0);
$opts{'upgrade'} = $_config->get('APT::Fu::Upgrade',0);

# I couldn't have possible thought of a cheesier name for this option...
$opts{'sprinkle'} = $_config->get('APT::Fu::SprinkleFrequency',12);

$opts{'newest-versions'} = $_config->get_bool('APT::Fu::NewestVersions',0);
$ENV{'DEPORDER'} = 'newest' if ($opts{'newest-versions'});

if ($_config->get_bool('APT::Fu::StrictMode',0)) {
	print STDERR ("Strict mode enabled, no changes will be made to the sources\n");
	$opts{'always-clean'} = 1;
	$opts{'relax-depends'} = 0;
	$opts{'change-version'} = 0;
	$opts{'modify'} = 0;
	$ENV{'MY_DEBIAN_ARCH'} = $XARCH{$ENV{'MY_DEBIAN_ARCH'}};
	archSync();
	$opts{'overwrite'} = 1;
	$opts{'cc-override'} = 0; # should'nt be needed since 'modify' is off
	$ENV{'DEPORDER'} = 'default,current,newest,local';
}

$opts{'source-only'} = $_config->get('APT::Fu::SourceOnly',0);
$opts{'source-upgrade-all'} = $_config->get('APT::Fu::SourceUpgradeAll',0);
$opts{'all-versions'} = $_config->get('APT::Fu::AllVersions',0);
$opts{'rescan-all'} = $_config->get_bool('APT::Fu::RescanAll',0);
$opts{'rebuild-all'} = $_config->get('APT::Fu::All',0);
$opts{'diff-opts'} = $_config->get('APT::Fu::DiffOptions','-x changelog -ruN');

if ($opts{'prompt'}) {
	if ($opts{'prompt'} =~/\ball\b/) {
		%prompt = map {$_ => 1} (keys %prompt);
	} else {
		foreach (split /\s*,\s*/, $opts{'prompt'}) {
			chomp $_;
			$prompt{$_} = 1;
		}
	}
}
$prompt{'apt'} = 1 unless $_config->get('APT::Get::Assume-Yes');
$prompt{'upgrade'} = 1 unless (-r $UPGRADEABLE);
if ($opts{'field'}) {
	foreach (split /\s*,\s*/, $opts{'field'}) {
		chomp $_;
		$Fields{$_} = abs($Fields{$_}) if defined ($Fields{$_});
	}
}

$opts{'verbose'} = $opts{'verbose'} - $opts{'quiet'};

if ($opts{'verbose'} < -1) {
	$_config->{'quiet'} = 2;
	$RDR = ' >/dev/null 2>/dev/null';
}

if (my $ur = $_config->get('APT::Fu::BuildDepType','R')){
	foreach my $t (split(/,/,$ur)){
		$REBUILD{$t} = 1 if (exists $REBUILD{$t});
	}
}

$opts{'threshold'} = $_config->get('APT::Fu::RebuildThreshold','upstream');

if (defined $Thresholds{$opts{'threshold'}}){
	$opts{'threshold'} = $Thresholds{$opts{'threshold'}};
} else {
	$opts{'threshold'} = 0;
}

1;

