$verDefault = '0.0-0';

# shortcuts/aliases since I'm a lazy typist
%cmdAlias = (
	'DU' => 'dist-upgrade',
	'du' => 'dist-upgrade',
	
	'U' => 'upgrade',
	
	'sdu' => 'src-dist-upgrade',
	'SDU' => 'src-dist-upgrade',
	
	'su' => 'src-upgrade',
	'SU' => 'src-upgrade',

	'ud' => 'update',
	'u' => 'update',
	
	
	'i' => 'install',
	'in' => 'install',
	
	'rm' => 'remove',
	'r' => 'remove',
	
	's' => 'source',
	
	'sbd' => 'src-build-dep',

	'bd' => 'build-dep',

	'ul' => 'update-local',
	
	'info' => 'build-info',
	'blog' => 'build-log',
	'binlog' => 'binary-log',
	
	'd' => 'dump',
	
	'res' => 'restore',
	
	'imp' => 'import-deb',
	
	'b' => 'build',
	
	'source-install' => 'src-install',
	'si' => 'src-install',
	'I' => 'src-install',
	
	'as' => 'arch-swap',
	'asd' => 'arch-swap-d',
	
	'sp' => 'src-policy',
	'source-policy' => 'src-policy',

	'rd' => 'resolve-depends',
	'rc' => 'resolve-conflicts',
	
);

@PKGARGV = ();
@WARNINGS = ();

$WARNABLE = 0;

%PRIO = (
	'required' => 5,
	'important' => 4,
	'standard' => 3,
	'optional' => 1, 
	'extra' => 0,
);

# used for specifying alternate versions of packages
%ALT = ();

# official Architecture supported by Debian:
# use this so we can still install binary packages from 
# Debian archives other than our own
%XARCH = (
	'i486' => 'i386',
	'i586' => 'i386',
	'i686' => 'i386',
	'pentium' => 'i386',
# note: I have limited knowledge of variants non-x86-linux architectures ...
	'alpha' => 'alpha',
	'arm' => 'arm',
	'hppa' => 'hppa',
	'hurd-i386' => 'hurd-i386',
	'i386' => 'i386',
	'ia64' =>  'ia64',
	'm68k' => 'm68k',
	'mips' => 'mips',
	'mipsel' => 'mipsel',
	'powerpc' => 'powerpc',
	's390' => 's390',
	'sh' => 'sh',
	'sparc' => 'sparc',
	# ??  ...  I'm even more lost here...
	'darwin-i386' => 'darwin-i386',
	'darwin-i486' => 'darwin-i386',
	'darwin-i586' => 'darwin-i386',
	'darwin-i686' => 'darwin-i386',
	'darwin-pentium' => 'darwin-i386',
	'darwin-powerpc' => 'darwin-powerpc',
	'hurd-i486' => 'hurd-i386',
	'hurd-i586' => 'hurd-i386',
	'hurd-i686' => 'hurd-i386',
	'hurd-pentium' => 'hurd-i386',
	'freebsd-i386' => 'freebsd-i386',
	'freebsd-i486' => 'freebsd-i386',
	'freebsd-i586' => 'freebsd-i386',
	'freebsd-i686' => 'freebsd-i386',
	'freebsd-pentium' => 'freebsd-i386',
	'netbsd-i386' => 'netbsd-i386',
	'netbsd-i486' => 'netbsd-i386',
	'netbsd-i586' => 'netbsd-i386',
	'netbsd-i686' => 'netbsd-i386',
	'netbsd-pentium' => 'netbsd-i386',
	'openbsd-i386' => 'openbsd-i386',
	'openbsd-i486' => 'openbsd-i386',
	'openbsd-i586' => 'openbsd-i386',
	'openbsd-i686' => 'openbsd-i386',
	'openbsd-pentium' => 'openbsd-i386',
	's390x' =>  's390x',
	'sh3' => 'sh3',
	'sh4' => 'sh4',
	'sh3eb' => 'sh3eb',
	'sh4eb' => 'sh4eb',
	'sheb' => 'sheb',
	'sparc64' => 'sparc64',
);

%prompt = (
	'source' => 0,
	'apt' => 0,
	'virtual' => 0,
	'pre-build' => 0,
	'fatal' => 0,
	'upgrade' => 0,
);

# special fields in our $SCACHE and $PCACHE that
# aren't package names or version numbers
%CacheField = (
	'RevDependsList' => 1,
	'ProvidesList' => 1,
	'Cached' => 1,
	'CachedStatus' => 1,
	'PolicyVer' => 1,
	'CurrentVer' => 1,
	'CurrentSrc' => 1,
);

%Fields = (
	'Package' => -3,
	
	'Binary' => -2,
	'Build-Conflicts-Indep' => -2,
	'Build-Conflicts' => -2,
	'Build-Depends-Indep' => -2,
	'Build-Depends' => -2,

	'Conflicts' => -1,
	'Depends' => -1,
	'Enhances' => -1,
	'Pre-Depends' => -1,
	'Recommends' => -1,
	'Replaces' => -1,
	'Suggests' => -1,
);

$fS = {
	'Package' => 1,
	'Version' => 1,
	'Binary' => 1,
	'Priority' => 1,
	'Build-Depends' => 1,
	'Build-Depends-Indep' => 1,
	'Build-Conflicts' => 1,
	'Build-Conflicts-Indep' => 1,
};

$fP = {
	'Package' => 1,
	'Version' => 1,
	'Source' => 1,
	'Priority' => 1,
	'Pre-Depends' => 1,
	'Depends' => 1,
	'Essential' => 1,
	'Filename' => 1,
	'Architecture' => 1,
	'Section' => 1,
};

%REBUILD = (
	'R' => 1,	# build depends including static libraries which *may* have been
			# linked into the final product
	'BE' => 0,	# a "build-essential" package
	'BD' => 0,	# a normal build-dependency
	'BDI' => 0,	# a build-dependency used for generating architecture-independent
			# targets (usually no reason to recompile them)
);

%Ab = (
	'Depends' => 'D',
	'PreDepends' => 'PD',
#	'Conflicts' => 'C',
#	'Replaces' => 'R',

	'Build-Depends' => 'BD',
	'Build-Conflicts' => 'BC',
	'Build-Depends-Indep' => 'BDI',
	'Build-Conflicts-Indep' => 'BCI',
);

%Ba = map { $Ab{$_}=>$_ } (keys %Ab);

%Thresholds = (
	'lv' => 2,
	'local' => 2,
	'local-version' => 2,
	'deb' => 1,
	'debian' => 1,
	'debian-version' => 1,
	'debian-revision' => 1,
	'ups' => 0,
	'upstream' => 0,
	'upstream-version' => 0,
);

%LocaleEnvs = (
	'LANG' => undef,
	'LC_ALL' => undef,
	'LC_COLLATE' => undef,
	'LC_CTYPE' => undef,
	'LC__FASTMSG' => undef,
	'LC_MESSAGES' => undef,
	'LC_MONETARY' => undef,
	'LC_NUMERIC' => undef,
	'LC_TIME' => undef,
);

1;

