sub restoreC {
	my ($LAST,$tmp)= @_;
	my ($IN,$RM);
#	if ($USE_LIBAPT_PKG & 0x02) {
#		&initAptPkgCache;
#		foreach my $i (keys %$CACHE) {
#			if ($CACHE->{$i}->{'CurrentState'} eq 'Installed'){
#				unless (defined $LAST->{$i}) {
#					$RM->{$i} = 1;
#				}
#			}
#		}
#		foreach my $i (keys %$LAST) {
#			if ($CACHE->{$i}->{'CurrentState'} ne 'Installed'){
#				$IN->{$i} = 1;
#			}
#		}
#	} else {
	closeAptPkgCache();
	cacheStatus();
	foreach my $i (keys %$PCACHE) {
		next if (defined $CacheField{$i});
		next unless (defined $PCACHE->{$i}->{'CurrentVer'});
		unless (defined $LAST->{$i}) {
			$RM->{$i} = 1;
		}
	}
	foreach my $i (keys %$LAST) {
		unless (defined $PCACHE->{$i}->{'CurrentVer'}){
			$IN->{$i} = 1;
		}
	}
	
	return unless (( keys(%$RM) || keys(%$IN) ));
	fixPkgSys() if (!$tmp && !$opts{'simulate'});

	if ($opts{'simulate'}) {	
		foreach my $p (sort keys %$IN) { print "Inst $p \n";}
		unless ($tmp) {
			foreach my $p (sort keys %$RM) { print "Remv $p \n"; }
		}
	} else {
		unless ($tmp) {
	#		foreach my $p (sort keys %$RM) { print "Remv $p \n"; }
			aptGetIR('remove',keys %$RM);
		}
	#	foreach my $p (sort keys %$IN) { print "Inst $p \n"; }
		aptGetIR('install',keys %$IN);
	}
}

sub fixPkgSys {
	unless (rx("$DPKG --configure -a") == 0) {
		wLog("$! $? $ROOTX $DPKG --configure -a");
	}
	unless (rx("$APTGET -f install") == 0) {
		wLog("$! $? $ROOTX $APTGET -f install");
	}
}

sub sourceFetch {
	my $pkgs = shift;
	foreach my $p ( sort keys %$pkgs ) {
		foreach my $v (sort keys %{$pkgs->{$p}}) {
			if ($pkgs->{$p}->{$v}->{'Z'}) {
				my ($pa,$va) = aptGetS($p,$v);
				unless (($p eq $pa) && ($v eq $va)){
					wLog("S[$p != $pa] or [$v != $va]\n");
					$pkgs->{$p}->{$v}->{'Z'} = 0;
				}
			}
		}
	}
	return $pkgs; # do something with this...
}

sub extractMulti {
	my $pkgs = shift;
	foreach my $p ( sort keys %$pkgs ) {
		foreach my $v (sort keys %{$pkgs->{$p}}) {
			if ($pkgs->{$p}->{$v}->{'Z'}) {
				my ($pa,$va) = aptGetS_X($p,$v);
				unless (($p eq $pa) && ($v eq $va)){
					wLog("S[$p != $pa] or [$v != $va]\n");
					$pkgs->{$p}->{$v}->{'Z'} = 0;
				}
			}
		}
	}
	return $pkgs; # do something with this...
}


# note: this function is supposed to change the system package state
# (temporarily) even during simulation runs (warn user)
sub aptGetIR_nl {
	my $in = shift;
	return 0 unless ($#_ >= 0);
	if ($in=~/[A-Z]/){
		$in = lc($in).' --reinstall';
	}
	checkInstallable(@_) if ($in =~/install/);
	my $p = join(' ',sort(@_));
	mchomp($p);
	
	# always make 'temporary' installs for BDs noninteractive
	my $tmp = $ENV{'DEBIAN_FRONTEND'} ? $ENV{'DEBIAN_FRONTEND'} : undef;
	$ENV{'DEBIAN_FRONTEND'} = 'noninteractive';
	fixPkgSys();
	my ($inp,$rmp,$dirty) = simAptGet($in,$p,0);

	if (($prompt{'apt'}||$opts{'simulate'}) && promptApt($in,$inp,$rmp)) {
		return 1;
	}
	# dont worry about purging too much, see the EXIT function, which
	# unmarks the ones we want to keep
	foreach (keys %$rmp){ $Purge{$_} = 1; }
	foreach (keys %$inp){ $Purge{$_} = 1; }
	closeAptPkgCache();
	
	fAptGet("$ROOTX $APTGET $in -q",$p)== 0
	||EXIT("$! apt-get (temp) $in \n  $p  \n");
	$ENV{'DEBIAN_FRONTEND'} = $tmp if ($tmp);
}

sub promptApt {
	my ($in,$inp,$rmp) = @_;
	return 0 unless (defined $rmp || defined $inp);
	if (defined $inp) {
		print "The following packages will be INSTALLED\:\n ",
		join(' ',sort(keys(%$inp))), "\n";
	}
	if (defined $rmp) {
		print "The following packages will be REMOVED\:\n ",
		join(' ',sort(keys(%$rmp))), "\n";
	}
	print "Proceed? [Y/n]: ";
	my $d = <STDIN>; mchomp($d); $d = lc $d;
	return 1 if ($d eq 'n');
	return 0;
}



sub aptGetS {
	my ($src,$ver) = @_;
	lvchomp($ver);
	my $prefix = namePrefix($src);

	unless ($opts{'simulate'} || $opts{'print-uris'}) {	
		unless (sys("mkdir -p $BUILDDIR/$prefix/$src") == 0) {
			EXIT("$!: Unable to mkdir\n");
		}
		chdir "$BUILDDIR/$prefix/$src" 
		||EXIT("$!: unable to chdir (aptGetS($src,$ver))\n");
	}
	my ($ep,$ups,$deb) = splitVer($ver);
	sys("rm -rf $src-$ups.orig.tmp-nest") if (-d "$src-$ups.orig.tmp-nest");
	sys("rm -rf $src-$ups.tmp-nest") if (-d "$src-$ups.tmp-nest");
	my $dsc = $src.'_'.$ups.$deb.'.dsc';
	unless (-r $dsc && verifyDSC($dsc) == 0) {	
		unless (sys("$APTGET source -d --only-source $src=$ver")==0){
			EXIT("$! Failed to retrieve source: $src ($ver)\n");
		}
	}
	info(0,"Retrieved source: $src ($ver)\n");
	return ($src,$ver);
}

sub extractOnly {
	my ($src,$ver) = @_;
	lvchomp($ver);
	# epoch is not used in filenames
	my($ep,$ups,$deb) = splitVer($ver);
	my $prefix = namePrefix($src);
	my $sdir = "$BUILDDIR/$prefix/$src";
	chdir $sdir or EXIT("$!: unable to chdir to $sdir(extractOnly)\n");
	
	sys("rm -rf $src-$ups") if (-d "$src-$ups");
	sys("rm -rf $src-$ups.orig.tmp-nest") if (-d "$src-$ups.orig.tmp-nest");
	sys("rm -rf $src-$ups.tmp-nest") if (-d "$src-$ups.tmp-nest");
	my $oldmask = umask 0022;	
	unless (sys("$DPKGSRC -x -sn $src\_".$ups.$deb.'.dsc') == 0) {
		EXIT("$! unable to extract source for $src [$ver]");
	}
	unless ($ROOTX){
		my @ss = stat($sdir);
		# some archives extract with funny permissions when root
		sys("chown --recursive $ss[4]:$ss[5] $src-$ups");
	}
	umask $oldmask;
	info(0,"Extracted $src ($ver) to: ",cwd);
	return ($src,$ver);
}

sub aptGetS_X {
	my ($src,$ver) = @_;
	aptGetS($src,$ver);
	extractOnly($src,$ver);
	return ($src,$ver);
}

# in case un-installable versions are passed to aptGetIR/_nl
# attempts to reduce usage of the fail-safe re-run features of simAptGet
# and fAptGet
sub checkInstallable {
	my $tmp;
	
	if ($#_ > 0) {
		foreach my $pp (@_){
			my $x = ($pp=~/^\s*([^\=]+)/);
			$tmp->{$x} = 0;
		}
		# so we don't call apt-cache $#_+1 times repeatedly
		policy2CacheM($tmp);
	}
	undef $tmp;
	foreach my $p (@_) {
		my ($pp,$vv);
		if ($p =~ /([\d\w\-\.\+]+)\=([\d\w\-\.\+\:]+)/) {
			($pp,$vv) = ($1,$2);
			if ($ALT{$pp}){
				# kill redundant virtual packages HERE
				$p = '';
				next;
			}
			if (isVInstalled($pp,$vv) == 0){
			# don't empty out the argument in case the user has
			# disabled version incrementing
				$p = '' if ($vv =~ /\.aptfu\.\d+/);
				next;
			} elsif (my $lv = localVer($pp)){
				my $sv = $lv;
				lvchomp($sv);
				if ($sv eq $vv) {
					$p = "$pp=$lv";
					next;
				}
			} elsif (P_isInstallable($pp,$vv) == 0){
				$p = $pp if ($vv eq P_verDefault($pp));
				next;
			}
		}
		($pp) = ($p =~ /^\s*([\d\w\-\.\+]+)/);
		if ($ALT{$pp}){
			# kill redundant virtual packages HERE
			$p = '';
			next;
		}
		my $pvd = P_verDefault($pp);
		if ((P_isInstallable($pp,$pvd) != 0)
		&& (isInstalled($pp) != 0)){
			wLog("$p/$pp=$pvd not installable, skipping.");
			$p = '';
			next;
		}
	}
}

sub aptGetIR {
	my $in = shift;
	return 0 unless ($#_ >= 0);
	if ($in=~/[A-Z]/){
		$in = lc($in).' --reinstall';
	}
	$in .= ' --purge' if ($opts{'autopurge'});

	checkInstallable(@_) if ($in =~/install/);

	my $p = join ' ', sort @_;
	
	$LASTDUMP = &DUMP unless (defined $LASTDUMP);
	closeAptPkgCache();
	foreach my $r (keys %$rmp) { delete $tmp{$r} if ($tmp{$r})}
	fixPkgSys();
	my ($inp,$rmp,$dirty) = simAptGet($in,$p,0);
	return if ($opts{'simulate'});

	if ($prompt{'apt'} && promptApt($in,$inp,$rmp)) {
		return 1;
	}

	fAptGet("$ROOTX $APTGET $in", $p)==0 ||EXIT("$! apt-get $in\n  $p  \n");
	$inp = testDepTree($inp);
	my %tmp;
	open FL, $LASTDUMP || EXIT("$! < $LASTDUMP");
	while (<FL>){ $tmp{$1} = $2 if (/^(\S+)\s+(\S+)/) }
	close FL;
	
	foreach my $p (keys %$inp) {
		my ($pp,$vv) = split /=/,$p;
		$tmp{$pp} = currentVer($pp);
	}
	
	open FH, "> $LASTDUMP" or EXIT("$! > $LASTDUMP\n");
	foreach my $i (sort keys %tmp){ 
		print FH "$i $tmp{$i}\n";
	}
	close FH;

	if ($dirty) {
		cacheStatus();
		$LASTDUMP = &DUMP;
		wLog("Package restoration may not work correctly\n",
		"`apt-get --simulate $in $p` failed to log ",
		"changes but the actual '$in' ",
		"procedure completed successfully.\n");
	}
	return 0;
}

sub simAptGet {
	my ($in,$p,$dirty) = @_;
	$dirty = 0;
	$p =~ s/\s+/ /g;
	# HACK: apt-get --simulate may fail with dpkg --force-architecture
	# and -oAPT::Architecture=$XARCH{$ENV{'MY_DEBIAN_ARCH'}}
	mchomp(my $AG = $APTGET);
	$AG =~s/\s+.*$//;
	my ($inp,$rmp);

	my @args = split(/ /,$p);
	my $now;
	my $last = $p;
	for (my $i = -1; $i <= $#args; ++$i){
		info(2,"$ROOTX $AG --simulate --force-yes -y -q $in $p 2>&1|");
		open PIPE,"$ROOTX $AG --simulate --force-yes -y -q $in $p 2>&1|"
		||EXIT("$! $ROOTX $AG --simulate -y -q $in $p");
		while (<PIPE>) {
			info(1,$_);
			if (/^Inst\s+(\S+)/){
				$inp->{$1} = 0;
			} elsif (/^Remv\s+(\S+)/){
				$rmp->{$1} = 0;
			# even if there is a Conf error on a pkg, the 
			# Inst or Remv line should already be printed
			} elsif (/^E:/ && /internal error/i &&
			/could not/i && /immediate config/i && /(\S+)\s*$/i){
				$now = $1;
				$p =~s/([^\w\d\.\+\=\-\:])\Q$now\E([^\w\d\.\+\=\-\:])/$1$2/g;
			} elsif (/unmet\s+dependencies/i ||
			( /Version/ && /was\s+not\s+found/)) {
				if ($dirty & 0x4) {
					$dirty ^= 0x4;	
				} else {
					$dirty |= 0x4;	
				}
			} elsif (/([\w\d\.\+\-]+):\s+Conflicts:\s+([\w\d\.\+\-]+)/){
				my ($one,$two) = ($1,$2);
				$p =~ s/(?:[^\w\d\.\+\-]+|^)\Q$one\E(?:[^\w\d\.\+\-]+|$)/ /;
				print STDERR "APT-Fu: Not installing $one since it conflicts with $two\n";
			}
		}
		if ($now) {
			undef $now;
		} elsif ($dirty & 0x4) {
#			wLog("Removing version information passed to $p");
			$p =~s/\=\S+//g;
#			wLog("Removed version information: $p");
		} else {
			last;
		}
		close PIPE or $dirty = 1;
		last if ($p eq $last);
		last unless ((keys %$inp || keys %$rmp) && !$dirty);
	}
	return ($inp,$rmp,$dirty);
}

sub fAptGet {
	my ($cmd,$p) = @_;
	$p =~ s/\s+/ /g;
	my @args = split(/ /,$p);
	my $now;
	my $dirty = 0;
	$cmd .= " --simulate " if ($opts{'simulate'});
	
	my $last = $p;
	for (my $i = -1; $i <= $#args; ++$i){
		info(0,"$cmd $p 2>&1 |");
		open AG,"$cmd $p 2>&1 |"|| EXIT("$! $cmd $p 2>&1 | (fAptGet)");
		while (<AG>){
			info(0,$_) unless (/already the newest version/);
			if (/^E:/ && /without/ && /--force-yes/) {
				$dirty |= 0x1 
			} elsif (/^E:/ && /internal error/i &&
			/could not/i && /immediate config/i && /(\S+)\s*$/i){
				$now = $1;
				$p =~s/([^\w\d\.\+\=\-\:])\Q$now\E([^\w\d\.\+\=\-\:])/$1$2/g;
			} elsif (/architecture/ 
			&& /\s*\(([^\)]+)\)[^\(]+\(([^\)]+)\)/){
				if (($XARCH{$1} eq $XARCH{$2}) &&
				($cmd !~ /--force-architecture/)){
			#		wLog("Enabling --force-architecture in dpkg");
					$cmd .= " -oAPT::Architecture=$XARCH{$ENV{'MY_DEBIAN_ARCH'}}"
					.' -oDPkg::Options::=--force-architecture';
					$APTGET .= " -oAPT::Architecture=$XARCH{$ENV{'MY_DEBIAN_ARCH'}}"
					.' -oDPkg::Options::=--force-architecture';
				}
			} elsif (/unmet\s+dependencies/i ||
			( /Version/ && /was\s+not\s+found/)) {
				if ($dirty & 0x4) {
					$dirty ^= 0x4;	
				} else {
					$dirty |= 0x4;	
				}
			} elsif (/([\w\d\.\+\-]+):\s+Conflicts:\s+([\w\d\.\+\-]+)/){
				my ($one,$two) = ($1,$2);
				$p =~ s/(?:[^\w\d\.\+\-]+|^)\Q$one\E(?:[^\w\d\.\+\-]+|$)/ /;
				print STDERR "APT-Fu: Not installing $one since it conflicts with $two\n";
			}
		}
		close AG or $dirty |= 0x1;
		if ($now) {
			sys("$cmd --force-yes $now");
			undef $now;
		} elsif ($dirty & 0x4) {
#			wLog("Removing version information passed to $cmd $p");
			$p =~s/\=\S+//g;
#			wLog("Removed version information: $cmd $p");
		} else {
			last;
		}
		last if ($p eq $last);
		last unless ((keys %$inp || keys %$rmp) && !$dirty);
	}
		
	return 0 unless ($dirty & 0xff);
	if ($dirty & 0x1){
		$cmd .=' --force-yes';
#		wLog("--force-yes APPENDED to $cmd");
	}
	return sys("$cmd $p");
#	unless (sys("$cmd $p") == 0) {
#		# ok, we get desperate here...
#		my $ret = 0;
#		foreach $pp (split /\s+/,$p) {
#			$ret |= sys("$cmd $pp");
#		}
#		return $ret;
#	}
}

1;
