# this contains the automated source package modification code
# and what not
#
# also has an option for manually editing stuff by spawning a new shell

# customArchHax(@filelist)
# goes through each file in @_ and applies changes to them
sub customArchHax {
	return unless ($ENV{'DEBIAN_BUILDGCCVER'} || $opts{'cc-override'} || 
	($XARCH{$ENV{'MY_DEBIAN_ARCH'}} ne $ENV{'MY_DEBIAN_ARCH'}));

	my $mod;
	chomp (my $SYST = `$DPKGARCH -qDEB_HOST_GNU_SYSTEM`);
	# XXX modify to use Tie::File in Perl 5.8 in Woody++
	foreach my $f (@_){
		chomp $f;
		next unless (-w $f);
		$mod->{$f} = 0;
		info(3,"Scanning $f");
		open FD, $f or EXIT("$! < $f (customArchHax)");
		#slurpage :P
		my (@new,@old);
		while (<FD>) {
			push @old, $_;
			if (/\S/) {
				$mod->{$f} += controlArch($_);
				$mod->{$f} += makefileArch($SYST,$f,$_);
			}
			push @new, $_;
		}
		close FD;
	
		open FD, "> $f" || EXIT("$! > $f (customArchHax)");
		print FD @new if (@new);
		close FD;
		
		if ($mod->{$f}){
			my $time = myDate(time);
			iLog("swap/append (",cwd,") file: $f - lines: $mod->{$f}");
			open FD,"> $f.apt-fu.old.$time" 
			||EXIT("$! > $f.apt-fu.old.$time (customArchHax)");
			print FD @old;
			close FD;
			sleep 1 if (myDate(time) eq $time);
		}
	}

	# all of these functions work across a SINGLE LINE 
	sub makefileArch {
		my $SYST = shift;
		my $f = shift;
		return 0 if (/^\s*#/);
		# conditionals: 
		# ifeq ($(DEB_BUILD_ARCH), $XARCH{ENV{'MY_DEBIAN_ARCH'}})... etc
		if(
		!(/(?:[^-])$ENV{'MY_DEBIAN_ARCH'}(?:[^-])/) 
		&& ( /if(?:neq)?/
		&& /\(|\[/ && /\)|\]/
		&& /BUILD|ARCH|GNU|CPU|HOST|SYSTEM|TYPE|TARGET|ALIAS/i 
		&& /(?:[^-])$XARCH{$ENV{'MY_DEBIAN_ARCH'}}(?:[^-])/) ){
			s/([^-])$XARCH{$ENV{'MY_DEBIAN_ARCH'}}([^-])
			/$1$ENV{'MY_DEBIAN_ARCH'}$2/gx;
			return 1; 
		} elsif (/\b(?:[a-z0-9]+)-$SYST\b/go) {
			return 0 if (/\b$ENV{'MY_DEBIAN_ARCH'}-$SYST\b/);
		# s/i386-linux/i686-linux/
			my @tmp = split(/,/, $_);
			my $r = 0;
			foreach my $foo (@tmp) {
				if ($foo =~ /([a-z0-9]+)-$SYST/) {
					if ((defined $XARCH{$1}) && 
					($XARCH{$1} 
					eq $XARCH{$ENV{'MY_DEBIAN_ARCH'}})){

if (($#tmp>1) || /--/){
	# for the binutils-multiarch target and ilk:
	$foo .= ",$ENV{'MY_DEBIAN_ARCH'}-$SYST";
} else {
	$foo =~	s/$1-$SYST/$ENV{'MY_DEBIAN_ARCH'}-$SYST/;
}
++$r;
					}
				}
			}
			$_ = join(',',@tmp) if (@tmp);
			return $r;
		} elsif (/^\s*[A-Z\_\-]+\s*=\s*$XARCH{$ENV{'MY_DEBIAN_ARCH'}}\s*$/){
			s/([^-])$XARCH{$ENV{'MY_DEBIAN_ARCH'}}([^-])
			/$1$ENV{'MY_DEBIAN_ARCH'}$2/gx;
			return 1; 
		} elsif (/([^-])$XARCH{$ENV{'MY_DEBIAN_ARCH'}}([^-])/ && 
		!(/$ENV{'MY_DEBIAN_ARCH'}/)) {
			wLog("May need manual editing \\\n$f in (",cwd,")\:\n$_");
			spawnShell() if ($opts{'pre-build'});
			return 0;
		} elsif (/(dpkg\s+\-\-print.+architecture)/i) {
			my $dp = $1;
			iLog("replacing (deprecated) $dp with dpkg-architecture -qDEB_HOST_ARCH in $f");
			s/\Q$dp\E/dpkg-architecture -qDEB_HOST_ARCH/x;
			return 1;
		# fix to get pentium-builder to compile glibc
		# and other source packages that specify a 
		# GCC version == DEBIAN_BUILDGCCVER
		} elsif ( ($f !~ /control/) && !(/\:\s/)
		&& $ENV{'DEBIAN_BUILDGCCVER'} 
		&& !(/[\,\<\>]/) && !(/echo/i) 
		&& ((-T '/usr/bin/gcc') || (-T '/usr/bin/g++')) &&
		(/(?:\s|\=)(g(?:c|\+){2})\-([\d\.]+)(?:\s|$)/)) {
			return 0 unless (defined $1 && defined $2);
			my ($cc,$vv) = ($1,$2);
			if ( $opts{'cc-override'}
			||($ENV{'DEBIAN_BUILDGCCVER'} eq $vv)){
				s/\Q$cc-$vv\E/$cc/g;
				iLog("gcc-front end enabled: ",
				"$cc-$vv => $cc in $f\: $_");
				return 1;
			}
		} elsif (/dpkg-architecture/i ||
		# a better way for handling \ newlines may be needed...
		/\-qDEB\_(?:HOST|BUILD)\_/
		){
			my $ret = 0;
			if (/\s\-f\s/) {
				iLog("overriding -f on dpkg-architecture in $f");
				$ret += s/\s\-f//;
			}
			if (/\s\-a(\S+)/) {
				iLog("overriding -a$1 on dpkg-architecture in $f");
				$ret += s/\s\-a\S+//;
			}
			if (/\s\-t(\S+)/) {
				iLog("overriding -t$1 on dpkg-architecture in $f");
				$ret += s/\s\-t\S+//;
			}
			return $ret;
		}
		return 0;
	}
	# all of these functions work across a SINGLE LINE 

	sub controlArch {
		# this should work on some variable defs in makefiles, too
		return 0 if (/^\s*#/); 
	        if (/(?:\[|\s|^)$XARCH{$ENV{'MY_DEBIAN_ARCH'}}(?:$|\]|\s)(?:[^\)\-])?/ 
		&& !/$ENV{'MY_DEBIAN_ARCH'}/) {
			s/((?:\[)|(?:\s))$XARCH{$ENV{'MY_DEBIAN_ARCH'}}
			/$1$XARCH{$ENV{'MY_DEBIAN_ARCH'}} $ENV{'MY_DEBIAN_ARCH'}/gx;
			return 1;
		} 
		if (/(?:\[|\s|^)\!$XARCH{$ENV{'MY_DEBIAN_ARCH'}}(?:[^\)\-])?/ 
		&& !/\!$ENV{'MY_DEBIAN_ARCH'}/) {
	        	s/((?:\[)|(?:\s))!$XARCH{$ENV{'MY_DEBIAN_ARCH'}}
			/$1!$XARCH{$ENV{'MY_DEBIAN_ARCH'}} !$ENV{'MY_DEBIAN_ARCH'}/gx;
			return 1;
		}
	}
}

# optRun - runs options file
# this runs inside the $sdir/$src_$ups directory (called by applyCustom)
# *** XXX no chdirs here XXX *
sub optRun {
	my $o = shift;
	my ($run,@ran);
	if (-r $o) {
		$run = $o;
		@ran = @_;
		undef $o;
	} else {
		$run = shift @{$o->{'run'}};
		@ran = @{$o->{'run'}};
		@{$o->{'run'}} = ($run,@ran);
	}
	foreach (@ran) { 
		if (basename($_) eq basename($run)){
			#wLog("$run , skipped (eq $_)");
			# skip already run files (avoid infinite looping)
			shift @{$o->{'run'}};
			return $o;
		}
	}

	my ($src,$ver) = readChangelog('debian/changelog');
	if ((defined $o->{'S'}) && (defined $o->{'V'}) && 
	(($o->{'S'} ne $src) || ($o->{'V'} ne $ver))){
		wLog("SRC: $o->{'S'} ($o->{'V'}) ne SRC: $src ($ver) in optRun($run), Skipped");
		shift @{$o->{'run'}};
		return $o;
	} elsif (!defined $o) { 
		$o = mkSIObj($src,$ver);
	}
	
	$o->{'var'}->{'SRC'} = $src;
	$o->{'var'}->{'VER'} = $ver;
	$o = syncVars($o);	
	@{$o->{'run'}} = ($run,@ran);

	if ($o->{'prompt'}->{'pre-build'}){
		my $d = 'y';
		print "Parse $run modifications? [Y/n]: ";
		$d = <STDIN>; mchomp($d); $d = lc $d;
		return $o if ($d eq 'n');
	}
	our ($bd); # this holds all the build-deps|conflicts we're modifying
	infon(0, "Running: \'$run\'");
	# nesting file opens are bad when INC is used, so we must slurp here
	$fh = zOpen($run);
	my @slurp = ();
	while (<$fh>) {
		next if (/^[^A-Z\_\+\-\!]/);
		last if (/^END/);
		push @slurp, $_;
		infon(0, ".");
	}
	close $fh;
	infon(0,"\n");
	my $th = undef;
	foreach my $L (@slurp){ 
		infon(5,$L);
		$L =~ s/([^\\])\$([A-Z\_]+)/$1$o->{'var'}->{$2}/g;
		if ($L =~ /^VAR\s+([A-Z\_]+)\s*=\s*([^\n]+)\n/){
			my ($key,$val) = ($1,$2);
			if ($val =~ /^(.*)\`([^\`]+)\`(.*)$/){
#				my ($one,$three) = ($1,$3);
				chomp($val = `$2`);
				mchomp($val = $1.$val.$3);
			}
		#	info(-2,"$key = $val");
			$o->{'var'}->{$key} = $val;
		} elsif ($L =~ /^SRC\s+(.*)$/) {
			my $dep = $1;
			if (defined $th->{'NEG'}) {
				wLog("SRC and !SRC definitions intermixed in: ",
				"$run.  Ignored $dep");
				next;
			}
			$dep =~ s/\(|\)|\s+//g;
			if ($dep =~ /^([^\>\<\=]+)([\>\<\=]+)?(\S+)?/){
				my $pn = $1;
				my $pe = (defined $2) ? $2 : '>=';
				my $pv = (defined $3) ? $3 : $verDefault; 
				($th->{$pn}->{'e'},$th->{$pn}->{'v'}) = ($pe,$pv);
			}
		} elsif ($L =~ /^!SRC\s+(\S+)\s+$/){
			$th->{$1} = 1;
			$th->{'NEG'} = 1;
		#} elsif ($L =~ /^END\s+/){
		#	last;
			#shift @{$o->{'run'}};
			#return $o;
		} elsif ($L =~ /^[A-Z\+\-]/){
			if (defined $th && $th->{'NEG'}){
				if ($th->{$src}){
				info(0, " Skipped rest for $src ($ver)");
				#	wLog("Remaining lines of optRun($run) ",
				#	"skipped for $src ($ver)");
				#	shift @{$o->{'run'}};
				#	return $o;
					last;	
				}
			} elsif (defined $th) {
				unless ($th->{$src} && $VS->check_dep($ver,
				$th->{$src}->{'e'}, $th->{$src}->{'v'})){
					info(-1,
					" Skipped rest for $src ($ver)");
#					wLog("optRun($run) skipped for: ",
#					"$src ($ver)");
					#shift @{$o->{'run'}};
					#return $o;
					last;
				}
			}
			$o = runLine($L,$o);
		}
	}
	undef @slurp;
	
	sys("chmod +w debian/control");
	if (-w 'debian/control') {
		editDctrl('debian/control');
	} else { 
		wLog("debian/control not writeable in ", cwd);
	}
	
	unless (($run =~/PREDIFF/) || !$o->{'opts'}->{'change-version'}){
		dch("Ran optFile: $run");
	}
	return $o;
	
	sub editDctrl {
		my $f = shift || 'debian/control';
		my $fh;
		$fh = zOpen($f);
		my ($nbd,$in,$last,@new,@idx);
		while (<$fh>){
			if (/^$/) {
				if ($in) {
					undef $in;
					# add previously undefined fields
					foreach my $x (keys %{$bd->{'in'}}){
						if ($bd->{'in'}->{$x} == 0){
							push @new,"\@$Ba{$x}\@";
							push @idx, $#new;
							$bd->{'in'}->{$x} = 2;
						}
					}
				}
				undef $last;
				push @new, $_;
			} elsif (/^Source:\s+\S+/){
				$in = 1;
				push @new, $_;
			} elsif ($in && /^([A-Z\-]+):\s+(.*)$/i){
				undef $last;
				my ($k,$v) = ($1,$2);
				$k =~ s/(\b)(\w)/$1\u$2/g;
			# hold the new Build-(Depends|Conflicts)(-Indep)
			# till later.  Index the line where the field will
			# be modified
				if ((defined $Ab{$k}) && $bd->{$Ab{$k}}) {
					$nbd->{$k} = $v;
					$last = $k;
					push @new, "\@$k\@\n";
					push @idx, $#new;
					$bd->{'in'}->{$Ab{$k}} = 1;
				} else {
					push @new, $_;
				}
			} elsif ($in && $last && /^\s+/){
				$nbd->{$last} .= $_;
			} else {
				undef $last;
				push @new, $_;
			}
		}
		close $fh;
		if (@idx) {
			my $time = myDate(time);
			rename($f,"$f.apt-fu.old.$time")
				||EXIT("$!:mv $f.apt-fu.old.$time");
			foreach (@idx) {
				my ($t) = ($new[$_] =~/\@([^\@]+)\@/);
				my $p = $nbd->{$t} ? $nbd->{$t}: '';
				#$bd->{$Ab{$t}}[0];
#				# make the line EASY for me to parse:
				if ($p =~/\S/) {
					$p =~ s/(?:^\s+|\n|\s+$)//g;
					$p =~ s/(\||,)(\S)/$1 $2/g;
					$p =~ s/(\S)(\||\(|\[)/$1 $2/g;
					$p =~ s/(\S)\,/$1 \,/g;
					$p = " $p ,";
				}
				# note to self: \Q\E is good 
				my @tf = split /\s*,\s*/, $p;
				foreach (@{$bd->{$Ab{$t}}}){
					if (/^\!(\S+)$/) {
						my $m = $1;
			#			print "-M $m\n";
			#			print "PRE $p\n";
						$p =~ 
						s/(?:[^,]*) \Q$m\E (?:[^,]*),//;
			#			print "DEL $p\n\n";
					} else {
						my $m = $_;
			#			print "+M $m\n";
			#			print "PRE $p\n";
						$p .= " $m ," unless ($p =~ 
						s/(?:[^,]*) \Q$m\E (?:[^,]*),/ $m ,/);
			#			print "ADD $p\n\n";
					}
				}
				$p =~ s/(\S)\s+\,/$1\,/g;
				$p =~ s/,\s*$//;
				$new[$_] = "$t\:$p\n";
				info(2,"Changes to file: $f   line $_\:");
				info(2,"- $t\: $nbd->{$t}") if (defined $nbd->{$t});
				info(2,"+ $new[$_]");
			}
			open NC, "> $f" || EXIT("$! (editDctrl) > $f");
			print NC $_ foreach (@new);
			close NC;
			sleep 1 if ($time eq myDate(time));
		}
		return 0;
	}
	
	sub runLine {
		my ($ln,$o) = @_;
		mchomp($ln);
		my $run = shift @{$o->{'run'}};
		my @ran = @{$o->{'run'}};
		@{$o->{'run'}} = ($run,@ran);

		if ($ln =~ /^ENV\s+([^\=\s]+)\s*\=\s*(.+)$/) {
			my ($k,$v) = ($1,$2);
			mchomp($v);
			$ENV{$k} = $v;
			dbg(0x400,"SETENV: $ln");
			&archSync;
		} elsif ($ln =~ /^ENV\s+([^\=\+\-\s]+)\s*\+\=(.+)$/){
			my ($k,$v) = ($1,$2);
			if (defined $ENV{$k}) {
				chomp($v);
				$ENV{$k} .= $v;
			} else {
				mchomp($v);
				$ENV{$k} = $v;
			}
			dbg(0x400,"+ENV: $ln");
			&archSync;
		} elsif ($ln =~ /^UNSET?\s+(\S+)\s*$/){
			delete $ENV{$1} if (defined $ENV{$1});
			dbg(0x400,"UNSET: $1");
			&archSync;
		} elsif ($ln =~ /^ENV\s+([^\=\s\+\-]+)\s*\-\=\s*(.*)\s*$/){
			dbg(0x400,"-ENV: $ln");
			my ($k,$v) = ($1,$2);
			return $o unless (defined $ENV{$k});
			dbg(0x400,"BEFORE $k = $ENV{$k}\n");
			mchomp ($v);
			$ENV{$k} =~ s/$v//;
			dbg(0x400,"AFTER $k = $ENV{$k}\n");
			&archSync;
		} elsif ($ln =~ /^\+?(BD|BC|BDI|BCI)\s+(.+)\s*$/) {
			addField($1,$2);
			dbg(0x400,"+ctrl: $ln");
		} elsif ($ln =~ /^\-(BD|BC|BDI|BCI)\s+(.+)\s*$/) {
			delField($1,$2);
			dbg(0x400,"-ctrl: $ln");
		} elsif ($ln =~ /^XC\s+(.*)$/){
			info(0,"XC $1");
			closeAptPkgCache();
			UNLOCK();
			system($1) == 0 || EXIT("$! X `$1` failed in $run");
			LOCK();
		} elsif ($ln =~ /^X\s+(.*)$/){
			info(0,"X $1");
			system($1) == 0 || EXIT("$! X `$1` failed in $run");
		} elsif ($ln =~ /^IPE\s+(.*)$/){
			my $time = myDate(time);
			system("/usr/bin/perl -i.apt-fu.old.$time -p -e $1")
			== 0 || EXIT("perl -i.apt-fu.old.$time -p -e $1");
			info(0,"In place edit $1");
			sleep 1 if (myDate(time) eq $time);
			#DBG dbg(0x400,"ED /usr/bin/perl -i.apt-fu.old.$time -p -e $1");
		} elsif ($ln =~ /^BUILD_CMD\s+(.+)$/){
			$o->{'BUILD_CMD'} = $1;
			mchomp($o->{'BUILD_CMD'});
			$o->{'BUILD_CMD'} =~/^(?:\"|\')|(?:\"|\')$/;
			$o->{'BUILD_CMD'} =~s/\s+/ /;
			unless ($o->{'BUILD_CMD'} =~/\Q$RULES_BUILD\E/) {
				wLog("BUILD_CMD for $o->{'S'} ($o->{'V'}) does not contain $RULES_BUILD");
			#	$o->{'BUILD_CMD'} .= " $RULES_BUILD";
			}
			iLog("new build command for $o->{S} ($o->{V}): $o->{BUILD_CMD}");
		} elsif ($ln =~ /^BINARY_CMD\s+(.*)$/){
			$o->{'BINARY_CMD'} = $1;
			mchomp($o->{'BINARY_CMD'});
			$o->{'BINARY_CMD'} =~/^(?:\"|\')|(?:\"|\')$/;
			$o->{'BINARY_CMD'} =~s/\s+/ /;
			unless ($o->{'BINARY_CMD'}=~/\Q$RULES_BINARY\E/) {
				wLog("BINARY_CMD for $o->{'S'} ($o->{'V'}) does not contain $RULES_BINARY");
				#$o->{'BINARY_CMD'} .= " $RULES_BINARY";
			}
			iLog("new binary command for $o->{S} ($o->{V}): $o->{'BINARY_CMD'}");
		} elsif ($ln =~ /^P\s+(\S+)/){
			my $f = $1;
			my $bf = basename($f);
			my $l = ($ln =~/\s+(\d+?)\s*$/) ? $1 : 0;
			#DBG dbg(0x400,"P: $ln\$2: $l");
			foreach my $pd (@{$o->{'patches'}}){
				my ($bp) = ($pd =~ /^(\S+)/);
				if ($bf eq basename($bp)) {
					iLog("PATCH: $f and $bp have the same",
					" basename. Skipped");
					return $o;
				}
			}
			if (($bf eq $run)|| $bf eq 'SELF'){
				$l = zPatch($run,$l,'');
				push @{$o->{'patches'}}, "$run $l";
				dch("Applied patch: $run");
				
				ECHO('debian/CLEAN.opt',"PR $run");
			} elsif (my $pa = selectPath($f,$o)){
				$l = zPatch($pa,$l,'');
				push @{$o->{'patches'}}, "$pa $l";
				dch("Applied patch: $f");
				
				ECHO('debian/CLEAN.opt',"PR $pa $l");
			} else {
				EXIT("PATCH $f not found, not applied");
			}
		} elsif ($ln =~/^PR\s+(\S+)/){
		# used internally by auto-generated debian/CLEAN.opt file
		# probably should't be used by the user manually
			my $f = $1;
			my $bf = basename($f);
			my $l = /\s+(\d+?)\s*$/ ? $1 : 0;
			#DBG dbg(0x400,"P: $ln\$2: $l");
			if (($bf eq $run)|| $bf eq 'SELF'){
				$l = zPatch($run,$l,'-R');
				info(0,"Unapplied patch: $run");
			} elsif (my $pa = selectPath($f,$o)){
				$l = zPatch($pa,$l,'-R');
				info(0,"Unapplied patch: $f");
			} else {
				EXIT("PATCH: $f not found, not applied");
			}
		} elsif ($ln =~ /^INC\s+(.*)$/){
			my $f = $1;
			my $bf = basename($f);
			foreach my $opt (@{$opt->{'run'}}) {
				my $br = basename($opt);
				if ($bf eq $br) {
					iLog("INC: $f and $opt have the same" ,
					" basename.  Skipped");
					return $o;
				}
			}
			my $inc = selectPath($f,$o);

			if ($inc){
				unshift @{$o->{'run'}},$inc;
				$o = optRun($o);
			} else {
				EXIT("INC: $f not found");
			}
		} elsif ($ln =~/^OPT\s+(\S+)\s*(\=\s*(\S+))?\s*$/) {
			$o->{'opts'}->{$1} = (defined $2) ? $3 : 1;
		} elsif ($ln =~/^PROMPT\s+(\S+)\s*(\=\s*(\S+))?\s*$/) {
			$o->{'prompt'}->{$1} = (defined $2) ? $3 : 1;
		} elsif ($ln =~/^ECHO\s*(.*)$/){
			system("/bin/echo $1");
		}
		$o = syncVars($o);	
		return $o;
	
		sub selectPath {
			my ($f,$o) = @_;
			my $inc = undef;
			if (-r $f) {
				#correct path given
				$inc = $f;
			} else {
				my $rp = dirname($o->{'run'}[0]);
				my $bf = basename($f);
				my ($src,$ver,$ups,$deb,$prefix) = 
				($o->{'S'},$o->{'V'},$o->{'ups'},$o->{'deb'},
				$o->{'prefix'});
				foreach my $pth ($rp, dirname($f),
				"$o->{'ddir'}/debian",
				split(/\s*\:\s*/,$ENV{'OPTPATH'})){
					chomp $pth;
					next unless $pth;
					my $new = $pth;
					$new =~s/\@src\@/$src/g;
					$new =~s/\@prefix\@/$prefix/g;
					if (-r "$new/$bf"){
						$inc = "$new/$bf";
						last;
					}
				}
			}
			return $inc;
		}
	}

	# although order of build-dependencies doesn't matter inside the
	# control file, they do matter when we're parsing them in our own
	# opt files:
	# Example:
	# 	+BD packagename 
	#	-BD packagename
	# 	# would yield no changes in any case
	# 	# however conversely:
	# 	-BD packagename
	# 	+BD packagename 
	# 	# would change things assuming packagename wasn't originally 
	# 	# declared in the Build-Depends field of the control file
	# Furthermore, something like:
	# 	-BD packagename
	# 	-BD packagename
	# 	-BD packagename
	# 	-BD packagename
	# 	+BD packagename 
	# 	# will cause packagename to be added, overriding the -BD fields
	# 	# before it 
	sub addField {
		my ($f,$val) = @_;
		mchomp($val);
		$val =~s/\"|\'//g;
		return unless ($val);
		if ($val=~/([^\<\>\)\(\s]+)\=([^\<\>\)\(\s]+)/) {
			$val = "$1 (= $2)";
		}
		unless ($val=~/\S\s+\S/){
			if ($val=~/\|/){
				wLog("OR dependencies not supported in terse",
				"format, skipped: $f $val\n",
				"Please use the Debian control file format for",
				"$Ab{$f} fields: ",
				"$f pkg (>= ver1) | pkg (<< ver2)");
				return;
			}
			my ($d,$e,$v) = ($val =~/([\d\w\-\.\+]+)
			\(?([\=\<\>]+?)([\.\d\+\-\w\:]+?)\)?$/x);
			$val = ($e && $v) ? "$d ($e $v)" : $val;
		}
		my ($p) = ($val=~/^(\S+)/);
		dbg(0x400,"$val added to $f, not $p");
		$bd->{'in'}->{$f} = 0;
		# make sure we didn't add a new field just to be conflicted
		push @{$bd->{'BD'}}, "\!$p";
		push @{$bd->{'BDI'}}, "\!$p";
		push @{$bd->{'BC'}}, "\!$p";
		push @{$bd->{'BCI'}}, "\!$p";
		push @{$bd->{$f}}, $val;
	}
	sub delField {
		my ($f,$val) = @_;
		mchomp($val);
		$val =~s/\"|\'//g;
		return unless ($val);
		if ($val=~/([^\<\>\)\(\s]+)\=[^\<\>\)\(\s]+/) {
			$val = $1;
		}
		$val =~s/\s+.*$//;
		dbg(0x400,"$val taken from $f");
		push @{$bd->{$f}}, "\!$val";
	}
	sub syncVars {
		my $o = shift;
		# ENV variables go into the var namespace only
		# if they're not redefined in var
		foreach my $env (keys %ENV) {
			unless (exists $o->{'var'}->{$env}){
				$o->{'var'}->{$env} = $ENV{$env};
			}
		}
		return $o;
	}
}


# Goes through a directory (usually $bdir/debian/) and looks for instances
# of $XARCH{$ENV{'MY_DEBIAN_ARCH'}} and swaps them with $ENV{'MY_DEBIAN_ARCH'}
sub archHaxD {
	my $o = shift;
	my $findcmd= 'find debian/';
	$o = cwd unless (defined $o);
	if (-d $o){
		chdir $o ||EXIT("unable to chdir $o (archHaxD)");
		$findcmd = 'find';
	} else {
		chdir $o->{'ddir'}
		||EXIT("unable to chdir $o->{'ddir'}(archHaxD)");
	}
	my $mlist;
	foreach my $f (`$findcmd`) {
		chomp $f;
		if ($f =~/(?:[^a-z0-9\-]|^)$XARCH{$ENV{'MY_DEBIAN_ARCH'}}(?:[^a-z0-9\-]|$)/){
			my $mf = $f;
			$mf =~ s/([^a-z0-9\-]|^)$XARCH{$ENV{'MY_DEBIAN_ARCH'}}([^a-z0-9\-]|$)/$1$ENV{'MY_DEBIAN_ARCH'}$2/g;
			unless (-e $mf){
				if ($f !~/(?:patch|diff)/i){
					iLog("COPY $f -> $mf (in ",cwd,"/debian/");
					sys("cp -a $f $mf");
					$f = $mf;
				}
			}
		}
		next if ($f =~/apt-fu\.old\.\d{8}\-\d{6}$/);
		next if ($f =~/changelog/);
		next if (isDiff($f) == 0);
		if ((boolGrep($XARCH{$ENV{'MY_DEBIAN_ARCH'}},$f) == 0)||
		(boolGrep('g(?:c|\+){2}-[\d\.]+',$f) == 0)){
			if ( $f=~/control/ ) {
				$mlist->{$f} = 1;
			}
			$mlist = isMakefile($f,$mlist);
			if ($mlist->{$f}){
				$mlist->{$f} = 1;
				$mlist = getMkIncludes($f,$mlist);
			}
		}
	}

	customArchHax(keys %$mlist) if (defined $mlist);

	sub boolGrep {
		my ($expr,$f) = @_;
		return 1 unless (-T $f);
		open my $fd, $f || EXIT("$! < $f boolGrep");
		while (<$fd>){
			if (/$expr/) {
				close $fd;
				return 0;
			}
		}
		close $fd;
		return 1;
	}

	sub getMkIncludes {
		my ($f,$mklist) = @_;
		open my $fd , $f || EXIT("$! < $f (getMkIncludes)");
		while (<$fd>){
			next if (/^\s*#/);
			if (/include\s+(\S+)/){
				#not smart enough to do variable expansion :P
				if (-T $1){
					$mklist->{$1} = 1;
				}
			} elsif (/\bmake\b\S*\s+-f\s+(\S+)/i){
				if (-T $1) {
					$mklist->{$1} = 1;
				}
			}
		}
		close $fd;
		return $mklist;
	}
	sub isDiff {
		my $f = shift;
		# must be in file or dir name first
		return 1 unless (($f=~/patch/) || ($f=~/diff/));
		my $fd = zOpen($f);
		while (<$fd>){
			if (/^diff/ || /^\*\*\* / || /----$/ ||
			/^>/ || /^</ ||  /\*\*\*\*$/ ||
			/^!/ || /^\@\@/ || /\@\@$/ || 
			/^\+/ || /^-/ ) { 
			# covers normal/unified/context diffs
				close $fd;
				return 0;
			}
		}
		close $fd;
		return 1;
	}
	sub isMakefile {
		# because `file` is inadequate
		my ($f,$mklist) = @_;
		if (($f =~/rules/) || ($f =~/\.mk$/)|| ($f =~/makefile/i)) {
			$mklist->{$f} = 1;
			#DBG dbg(0x1,"1: ADDED $f");
			return $mklist;
		}
		open FD, $f || EXIT("$! < $f (isMakefile)");
		while (<FD>){
			# afaik `:=' is only found in makefiles...
			if ((/^#/ && ( (/!\// && /make/) || /makefile/i) )
			|| /:=/) {
				close FD;
				$mklist->{$f} = 1;
				#DBG dbg(0x1,"2: ADDED $f");
				return $mklist;
			}
		}
		close FD;
		# last resort ..
		if(sys("make -n -f $f>/dev/null 2>&1")==0){
			$mklist->{$f} = 1;
			#DBG dbg(0x1,"3: ADDED $f");
		}
		return $mklist;
	}
}

sub changelogMod {
	my $o = shift;
	my $f;
	if (-r $o) {
		$f = $o;
	} else { 
		$f = $o->{'ddir'}."/debian/changelog";
	}
	return unless (-r $f);

#	fixLocales();
	my $host = hostname();
	my $un = (getpwuid($<))[0] || $ENV{'USER'} || $ENV{'LOGNAME'} || 'DefaultUser';
	$un = $_config->get('Apt::Fu::userinfo',"$un <$un\@$host>");
	$un =~s/\s+/ /g;
	mchomp($un);
	
	my $date = (defined $o->{'date'}) ? $o->{'date'} : time;
	
	open FH, $f|| EXIT("$! < $f (changelogMod)");
	my ($firstline, $text) = ('','');
	$firstline = <FH> while ($firstline =~ /^$/);
	
	{ 
		local $/;
		undef $/;
		$text = <FH>;
	}

	close FH;
	
	rename($f,"$f.apt-fu.old.$date");
	
	$firstline =~ /^(\S+)\s+\((\S+)\)/;
	
	my ($name, $version) = ($1, $2);

	# 822-date
	$date = date822($date);
	#strftime("%a, %e %b %Y %H:%M:%S %z",localtime($date)); 
	if ((defined $o->{'V'})  && ($o->{'V'} ne $version)
	&& ($o->{'V'} !~ /\Q$version\E/) && ($version !~ /\Q$o->{'V'}\E/) ){
		wLog("$version ne $o->{'V'}! in changelog");
	}
	$version = getFuVersion($name,$version);
	$o->{'V'} = $version;
	open FH, "> $f" || EXIT("$! > $f (changeLogMod)");
	print FH "$name ($version) apt-fu; urgency=low\n\n";
	print FH "  * Built locally by apt-fu.\n";
	print FH "\n -- $un  $date\n\n";

	print FH $firstline, $text;
	close FH ;
#	resetLocales();
	exit 0 if ($o eq $f);
	return $o;
}

sub date822 {
	chomp(my $date = `822-date`);
	return $date;
}

sub dch {
#	fixLocales();
	sys("$DCH -a @_") if (-x $DCH);
#	resetLocales();
}

# apply customizations to the source package
sub applyCustom {
	my $o = shift;
	my ($src,$ver) = ($o->{'S'},$o->{'V'});
	
	my($ep,$ups,$deb) = ($o->{'ep'},$o->{'ups'},$o->{'deb'});
	
	my $prefix = $o->{'prefix'};
	my $sdir = $o->{'sdir'};

	chdir $o->{'ddir'} or EXIT("chdir $o->{'ddir'}(applyCustom)");

	if (-r 'debian/CLEAN.opt') {
		optRun('debian/CLEAN.opt');
		unlink 'debian/CLEAN.opt';
	}
	
	foreach my $bn ( 'GLOBAL.opt', 
	"$src.opt", "$src\_$ups.opt", "$src\_$ups$deb.opt"){
		foreach my $pth ("$o->{'ddir'}/debian",
		split(/\:/,$ENV{'OPTPATH'})){
			chomp $pth;
			my $new = $pth;
			$new =~ s/\@src\@/$src/g;
			$new =~ s/\@prefix\@/$prefix/g;
			if (-r "$new/$bn") {
				unshift @{$o->{'run'}}, "$new/$bn";
				$o = optRun($o);
			} elsif (-r "$new/$bn.gz") {
				unshift @{$o->{'run'}}, "$new/$bn";
				$o = optRun($o);
			} elsif (-r "$new/$bn.bz2") {
				unshift @{$o->{'run'}}, "$new/$bn";
				$o = optRun($o);
			}
		}
	}

	return unless ( $o->{'patches'} || $o->{'prompt'}->{'pre-build'} ||
	$o->{'run'}||($ENV{'MY_DEBIAN_ARCH'}ne $XARCH{$ENV{'MY_DEBIAN_ARCH'}}));
	
	chdir $o->{'ddir'} or EXIT("chdir $o->{'ddir'}(applyCustom)");
	
	if ( ($XARCH{$ENV{'MY_DEBIAN_ARCH'}} ne $ENV{'MY_DEBIAN_ARCH'})
	||$ENV{'DEBIAN_BUILDGCCVER'} ||$opts{'cc-override'}) {
		&archSync;
		my $d = 'y';	
		if ($o->{'prompt'}->{'pre-build'}){
			print "Search and auto swap/append instances of \'",
			$XARCH{$ENV{'MY_DEBIAN_ARCH'}},
			"\' for \'$ENV{'MY_DEBIAN_ARCH'}\'",
			" in 'control' and Makefiles or ensure that a compiler",
			" front-end is used? [Y/n]: ";
			$d = <STDIN>; mchomp($d); $d = lc $d;
		} else { 
			$d = 1;
		}
		# this does a lot of stuff
		archHaxD($o) if ($d ne 'n') ;
	}
	$o = preBuildSH($o) if ($o->{'prompt'}->{'pre-build'});
	&archSync;
	closeAptPkgCache();
	return $o;
}

sub spawnShell {
	my $sh = $ENV{'SHELL'} || '/bin/bash';
	my $shrc = $_config->get('APT::FU::ShRc',"$APTFU/apt-fu.sh.rc");
	genBashRC($shrc) unless (-r $shrc);
	my $shopts = $_config->get('APT::FU::ShOpts',"--rcfile $shrc");
	UNLOCK();
	system("$sh $shopts");
	LOCK();
}

sub preBuildSH {
	my $o = shift;
	
	# do a dump here so the user can run `apt-fu build-dep`
	# inside the second shell and have the build-deps uninstalled
	# automatically later on.
	$LASTDUMP = &DUMP unless (defined $LASTDUMP);
	
	my $loop = 1;
	my $df;
	while ($loop) {
		# launch a new shell
		chdir $o->{'ddir'} || EXIT("chdir $o->{'ddir'} (prebuildSH)");
		spawnShell() if ($o->{'prompt'}->{'pre-build'});
		if (-r 'debian/POSTSHELL.opt'){	
			unshift @{$o->{'run'}}, 'debian/POSTSHELL.opt';
			$o = optRun($o);
		}
		# user does some hacking something here while the
		# new shell is running
		$loop = 0;	
		my $d = 'y';
		if ($o->{'prompt'}->{'pre-build'}) {
			print "Generate a diff for any changes made? [Y/n]: ";
			$d = <STDIN>; mchomp($d); $d = lc $d;
		}
		unless ($d eq 'n') {
			info(0,"Purging all *apt-fu.old.* files");
			system("find -name \"*apt-fu.old.*\"| xargs rm");
			
			chdir $o->{'sdir'} ||EXIT("$! chdir $o->{'sdir'}");
			
			if (-d $o->{'ddir'}) {
				if (-e $o->{'diffb'}) {
					wLog("$o->{'diffb'} already exists! Removed");
					sys("rm -rf $o->{'diffb'}") == 0
					|| EXIT("rm -rf $o->{'diffb'}");
				}
				# move the new build dir to B
				sys("mv $o->{'ddir'} $o->{'diffb'}") == 0
				|| EXIT("$! mv $o->{'ddir'} $o->{'diffb'}");
			}

			unless (-d $o->{'diffa'}){
				info(0,"Extracting $o->{'diffa'}");
				aptGetS($o->{'S'},$o->{'V'});
				extractOnly($o->{'S'},$o->{'V'});
				sys("mv $o->{'ddir'} $o->{'diffa'}") == 0
				|| EXIT("$! mv $o->{'ddir'} $o->{'diffa'}");
			}

			my $nf = "$o->{'diffb'}/debian/PREDIFF.opt";
			if (-r $nf){
				sys("mv $o->{'diffa'} $o->{'ddir'}") == 0
				|| EXIT("$! mv $o->{'diffa'} $o->{'ddir'}");

				chdir $o->{'ddir'}
				||EXIT("$! chdir $o->{'ddir'}(pre-build)");
				# this is so patches can be generated 
				# in case packages are not fully extracted
				# (as is common with lots of larger packages)
				# the user can put:
				# X debian/rules source.unpack
				# in the prediff.opt file, for example
				optRun($nf);
				if ($o->{'opts'}->{'always-clean'}) {
					sys("$FAKER debian/rules clean");
				}
				
				chdir $o->{'sdir'}||EXIT("$! chdir $o->{'sdir'}");
				
				sys("mv $o->{'ddir'} $o->{'diffa'}") == 0
				|| EXIT("$! mv $o->{'ddir'} $o->{'diffa'}");
			}
			
			if ($df = diffGen($o)){
				if (-r $nf) {
					my $dfn = "$df.new";
					
					open my $fd, "> $dfn" || EXIT("$! > $dfn");
					
					print {$fd} "# APT-Fu ($VERSION) auto-generated patch\n";
					print {$fd} "SRC $o->{'S'} (= $o->{'V'})\n";
					open my $pd, $nf || EXIT ("$! < $nf");
					while (<$pd>){ print {$fd } $_ }
					print {$fd} "\nP SELF 1\nEND\n";
					close $pd;

					open my $od, $df || EXIT ("$! < $df");
					while (<$od>){ print { $fd } $_ }
					close $od;
					
					close $fd;
					unlink $df;
					rename $dfn, $df;
				}
				
				if ($o->{'prompt'}->{'pre-build'}){
					print "View/edit $df ? [Y/n]: ";
					$d = <STDIN>; mchomp($d); $d = lc $d;
					if ($d ne 'n'){
						system('sensible-editor',$df)
					}
				}
				sys("$DZ $df");
			}
			
			sys("mv $o->{'diffb'} $o->{'ddir'}") == 0
			|| EXIT("$! mv $o->{'diffb'} $o->{'ddir'}");
			
			if ($o->{'prompt'}->{'pre-build'} && $df) {
				print "Make more changes? [y/N]: ";
				$d = <STDIN>; mchomp($d); $d = lc $d;
			} else { 
				$d = 'n'
			} 
			$loop = 1 if ($d eq 'y');
		}
	}
	if (-e $o->{'diffa'}){
		sys("rm -rf $o->{'diffa'}")==0||EXIT("$! rm -rf $o->{'diffa'}");
	}
	push @{$o->{'patches'}}, $df if ($df);
	return $o;
}

sub diffGen {
	my $o = shift;
	return unless ($o->{'opts'}->{'autodiff'});
	unless (-d $o->{'diffa'} && -d $o->{'diffb'}) {
		wLog("DIR: $o->{'diffa'} and $o->{'diffb'} don't exist!");
		return;
	}
	
	my $ext = 'diff';
	# assume these dirs have already been made
	
	sys("mkdir -p $o->{'sdir'}/PATCHES/autogen") == 0 
	|| EXIT("$!: unable to create dir $o->{'sdir'}/PATCHES/autogen");
	my ($adir,$bdir) = (basename($o->{'diffa'}),basename($o->{'diffb'}));
	
	chdir $o->{'sdir'} || EXIT("$!: chdir $o->{'sdir'}! (diffGen)");
	
	my $date = myDate(time);
	
	my $dname 
	= "$o->{'sdir'}/PATCHES/autogen/$o->{'ups'}$o->{'deb'}\_$date.$ext";
	
	my $dOpts = $o->{'opts'}->{'diff-opts'};	
	
	info(0,"diff $dOpts $adir $bdir");
	
	my $ret = system("diff $dOpts $adir $bdir > $dname");
	EXIT("$ret $!: diff $dOpts $adir $bdir > $dname") if ($ret == 2);
	return undef if ($ret == 0);
	
	$dname = cleanDiffs($o->{'sdir'},$dname);
	info(-1,"Auto-generated diff to $dname");
	
	sleep 1 if (myDate(time) eq $date);

	return $dname;
}

sub cleanDiffs {
	my ($sdir,$dname) = @_;
	return $dname unless (-x $IDIFF);
	my %fHash;
	foreach (<$sdir/PATCHES/autogen/*>){
		chomp;
		if ((-l $_) && (my $f = readlink $_)){
			unlink $f unless (-r $f);
			next;
		}
		$fHash{$_} = '/dev/null';
	}
	foreach my $F ((sort(keys(%fHash)))) {
		next unless ($fHash{$F} eq '/dev/null');
		foreach my $f ((sort(keys(%fHash)))) {
			next if ($f eq $F);
			next unless ($fHash{$f} eq '/dev/null');
			my $poo = 1;
		
			# avoid the obviously mis matched files
			my @statF = stat($F) or EXIT("$! stat $F");
			my @statf = stat($f) or EXIT("$! stat $f");

			# silently skip cleaning files > ~1 meg
			# interdiff takes too long
			if (($statf[7] > 0xfffff) || ($statF[7] > 0xfffff)){
				undef $poo;
			}

		#	aptGetIR_nl('install','patchutils') if (!-x $IDIFF);
			if ($poo) {
				open FD,"$IDIFF -z $F $f|"
				||EXIT("$! $IDIFF -z $F $f|");
				while (<FD>) {
					if (/\S/) {
						undef $poo;
						close FD;
						last;
					}
				}
				close FD;
			}
			$fHash{$f} = $F if ($poo);
		}
	}
	# keep the oldest patch in a series of identical ones
	foreach my $F (keys(%fHash)) {
		unless ($fHash{$F} eq '/dev/null') {
			if ($F eq $dname) {
				info(-1,"Auto-generated diff: ",
				basename($dname),
				" is identical to ", basename($fHash{$F}));
				$dname = $fHash{$F};
			}
			unlink $F unless ($opts{'simulate'});
		}
	}
	return $dname;
}

1;
