# various help stuff

sub HELP_COMMANDS {
	print "All apt-fu commands and aliases\n";
	foreach my $m (sort keys %modes) {
		next if ($m eq 'moo'); # :P
		print " $m";
		foreach my $al (sort keys %cmdAlias){
			if ($cmdAlias{$al} eq $m) {
				print "|$al";
			}
		}
		print "\n";
	}
	print "\n";
}

sub CONFIG_DUMP {
	$_config->dump();
}

sub HELP_DISCLAIMER {
print <<EOF
DO NOT file a bug report against this source package if YOU break it.  You
probably broke or forgot something if it won't build :P

Remember, the maintainers and upstream authors of this source package you're
about to edit put a lot of effort into making the source package the way it is
and is in no way responsible for what YOU do it (unless you submit a good fix
or patch that benefits the community).

If a package fails to build, try building with the --strict option enabled,
and disable any compiler/linker/assember front-ends/flags you may be using.
Unset any environment variables that affect the build.  Check Debian BTS
<http://bugs.debian.org> before submitting a bug report.

If APT-Fu breaks something with the source package (using poorly-written
optFiles and patches notwithstanding), then file a bug report against APT-Fu.
Although written for Debian, APT-Fu is not (yet) an official Debian package,
so submit bug reports directly to the author (me) for now.

Thank you for using APT-Fu.             -- Eric Wong <normalperson\@yhbt.net>

"apt-fu help-disclaimer" to repeat this message.
"apt-fu help-shell" for some help on using the new shell spawned by apt-fu
EOF
}

sub HELP_SHELL {
	printVersion();
	print <<EOF
ABOUT:
   APT-Fu can spawn a new shell while running to allow the user to
   manually modify the source package as they wish.  This is
   normally triggered by the --prompt=pre-build option.
   
   Hint: you can run "apt-fu build-dep <package>", or similar commands
   within this shell.  You can also run any debian/rules target before
   exiting this shell.

OPTFILES: (more info on APT-Fu optFiles is available in /usr/share/doc/apt-fu)
   
   debian/POSTSHELL.opt - this optFile runs in source package
   directory after the shell has exited

   debian/PREDIFF.opt - this optFile runs in the original source package
   directory when generating a diff.  It is useful for putting commands
   to extract the source tree and make sanely-sized diffs from it.

Don't know what you're doing? Just exit this shell by typing "exit" at
the terminal or hitting [Ctrl-D] to let the build proceed or read the
docs /usr/share/doc/apt-fu or the apt-fu(1) and optFile(5) manuals
EOF
}

sub HELP {
	printVersion();
	print <<EOF
Usage: apt-fu [options] command
       apt-fu [options] src-install pkg1 [pkg2 ...]

apt-fu - a source building and package installation tool for APT.

Common Commands: (many more commands supported, see apt-fu(1) man page)
   src-install - Download, build and install a binary package from source
   src-build-dep - Install source build-dependencies from source code
   src-upgrade - Perform an upgrade by building from source 
   src-dist-upgrade - Distribution upgrade by building from source
   source - Download a source archive, slightly different from apt-get(8)
   import-deb - Import a .deb package archive into the local repository
   help-alias - Show all commands and their shortcut aliases.

Common Options: (many more options supported, see apt-fu(1) man page)
   -s  No-act.  Perform ordering simulation (warning: this is slow).
   -R  Recursively build any build-dependencies from source, as well.
   -C  run the 'clean' target after 'build' and 'binary' in debian/rules
   -m=? Build for target architecture (see man page for details)
   -y  Assume-yes to package installations/removals
See the apt-fu(1) manual page and /usr/share/doc/apt-fu for more details
EOF
}
1;

