
sub getLocalMatches {
	my ($pkgs,$view) = @_;
	my $latest;
	my (@views) = (undef); # placeholder for $view[0]
	# ok... I'm really starting to hate this data structure
	# S_pickVers returns...
	foreach my $p (keys %$pkgs){
		foreach my $v (keys %{$pkgs->{$p}}){
			if ($pkgs->{$p}->{$v}->{'Z'}) {
				my $np = namePrefix($p);
				unless (chdir "$BUILDDIR/$np/$p/DEB") {
					next unless (chdir "$CACHEDIR/$np/$p");
				}
				$latest = readlink 'latest' if (-l 'latest');
				foreach my $d (sort <*>) {
					chomp $d;
					next unless (-d $d && !-l $d);
					foreach my $f (<$d/*>) {
						if ($f=~/\Q$view\E/){
							my $vv;
							$vv->{'f'} = cwd."/$f";
							$vv->{'b'} = "$p - $f";
							if (defined $latest 
							&& $f=~/\Q$latest\E/){
								$vv->{'b'} .= " (latest)";
							}
							$vv->{'S'} = $p;
							$vv->{'V'} = $v;
							push @views,$vv;
						}
					}
				}
			}
			next;
		}
	}
	return @views;
}

sub viewLocalInfo {
	my $view = shift;
	my $pkgs = S_pickVers(@_);
	my @views = getLocalMatches($pkgs,$view);
	if ($#views>0) {
		print "All files matching $view: /\n";
		foreach (my $i = 1; $i <= $#views; ++$i) {
			print $i, ". $views[$i]->{'b'}\n"
		}
		print "Select one or more: ";
		mchomp(my $in = <STDIN>);
		foreach my $s (split(/\D+/,$in)){
			zView($views[$s]->{'f'}) if (defined $views[$s]->{'f'});
		}
	} else {
		zView(%{$views[0]->{'f'}}) if (defined $views[0]->{'f'});
	}
}

#parseBINFO($f);

sub cleanLogDir {
	my %fHash;
	foreach (<$LOGDIR/*.log>){
		chomp;
		$fHash{$_} = '/dev/null';
	}
	foreach my $F (reverse(sort(keys(%fHash)))) {
		next unless ($fHash{$F} eq '/dev/null');
		foreach my $f (reverse(sort(keys(%fHash)))) {
			next if ($f eq $F);
			next unless ($fHash{$f} eq '/dev/null');
			if (cmpDump($F,$f)==0){
				$fHash{$f} = $F;
			}
		}
	}
	foreach my $F (keys(%fHash)) {
		unless ($fHash{$F} eq '/dev/null') {
			info(2,"UNLINK $F (identical to $fHash{$F})");
			unlink $F unless ($opts{'simulate'});
		}
	}
	sub cmpDump {
		my ($F,$f) = @_;
		my ($FF,$ff) = ('','');
		my $fh = zOpen($F);
		while (<$fh>){ $FF .= $1 if (/^(\S+)/) }
		close $fh;
		$fh = zOpen($f);
		while (<$fh>){ $ff .= $1 if (/^(\S+)/) }
		close $fh;
		#print "$f: $ff\n";
		#print "$F: $FF\n";
		return 0 if ($ff eq $FF);
		return 1;
	}
}


sub localPackageScan {
	return if (defined $LCACHE);
	my $lln = &localListName;
	my $f = {
		'Package' => 1,
		'Version' => 1,
		'Filename' => 1,
	};
	my $fh = zOpen($lln) || EXIT("$! localPkgScan($pkg,$ver)<$lln\n");
	$LCACHE = ctrl2Href($fh,$LCACHE,$f,'Package');
	close $fh;
}

sub IMPORT_DEB {
	localPackageScan();
	my $un = (getpwuid($<))[0] || $ENV{'USER'} || $ENV{'LOGNAME'} || 'DefaultUser';
	my $idir = "$MYCACHE/IMPORTED/$un";
	unless (-d $idir){
		sys("mkdir -m 0755 -p $idir") == 0 
		|| EXIT("$! mkdir -m 0755 -p $idir");
	}
	foreach my $f (@_){
#		if ($opts{'copy'} ||(-W $f && -w $f)) {
#			sys("mv $f $idir")==0 ||EXIT("mv $f $idir");
#		} els
		if (-r $f) {
			my $bn = basename($f);
			if (-e "$idir/$bn"){
				wLog("$idir/$bn already exists, skipped");
			} else {
				sys("cp $f $idir/$bn")==0
				||EXIT("cp -nsf $f $idir/$bn");
			}
		}
	}
	my $bin  = SCAN(<$idir/*.deb>);
	chmod 0644, <$idir/*>;
	&GEN_PKGLIST2;
}

sub localVer {
	my ($pkg) = @_;
	localPackageScan();
	if ($LCACHE->{$pkg}) {
		foreach my $v (
		sort { $VS->compare($b,$a)} keys %{$LCACHE->{$pkg}}){
			next if (defined $CacheField{$v});
			return $v;
		}
	}
	return $verDefault;
}

sub localAvail {
	my ($pkg,$ver) = @_;
	localPackageScan();
	return 1 unless (defined $LCACHE->{$pkg});
	return 1 unless (defined $LCACHE->{$pkg}->{$ver});
	return 0;
}

# local repository/source tree maintainance functions...

sub syncUserCache {
	return if ($CACHEDIR eq $MYCACHE);
	chdir $CACHEDIR or EXIT("$! chdir $CACHEDIR (syncUserCache)");
	foreach my $l (<$MYCACHE/*>){
		chomp $l;
		next unless (-l $l || -d $l);
		next if (-l $l && checkSymlink($l)==1);
		my $bl = basename($l);
		unless ($l =~/IMPORTED/) {
			my $pf = namePrefix($bl);
			if (($pf ne $bl) && ($l ne $pf)){
				sys("mkdir -m 0755 -p $MYCACHE/$pf") == 0
				||EXIT("$! mcache mkdir $MYCACHE/$pf");
				sys("mv $l $MYCACHE/$pf/") == 0
				||EXIT("$! mv $l $MYCACHE/$pf");
				next;
			}
		}
		foreach my $s (<$MYCACHE/$bl/*>) {
			chomp $s;
			next unless (-l $s || -d $s);
			next if (-l $s && checkSymlink($s) == 1);
			my $cl = basename($s);
			if (-l $s || -d $s ) {
				my ($clS,$clV,$mS,$mV);	
				foreach my $blog (<$CACHEDIR/$bl/$cl/*>) {
					chomp $blog;
					if ($blog =~ /\bbuild-info\.log/){
						($clS,$clV) = parseBINFO($blog);
						last;
					}
				}
				foreach my $blog (<$MYCACHE/$bl/$cl/*>){
					chomp $blog;
					if ($blog =~ /\bbuild-info\.log/){
						($mS,$mV) = parseBINFO($blog);
						last;
					}
				}
				if( ($clS && $clV && $mS && $mV)	
				&& ($clS eq $mS) 
				&& ($VS->compare($clV,$mV)>=0) ){
				#print "($clS,$clV,$mS,$mV)\n";	
				#	print "$clV >= $mV\n";
					next;
				}
			}
			$s = basename($s);
			unless (-d $bl) {
				rx("mkdir -m 0755 -p $bl")==0
				||EXIT("$! rx mkdir $bl");
			}
			rx("ln -nsf $MYCACHE/$bl/$s $bl/$s")== 0 
			||EXIT("$! ln -nsf $MYCACHE/$bl/$s $bl/$s");
		}
	}
}

sub parseBINFO {
	my $FH = zOpen($_[0]);
	my ($s,$v);
	while(<$FH>){
		if (/^SRC\s+(\S+)\s*(.*)/){
			$s = $1;
			$v = $2 if (defined $2);
		} elsif (/^VER\s+(.*)/){
		# XXX old Field from an old version of mine (never released)
			$v = $1;
		}
		if ($s && $v) {
			$v =~s/[^\.\d\+\-\:\w]+//g;
			close $FH;
			return ($s,$v);
		}
	}
	close $FH;
	return ($s,$v) if ($s && $v);
	wLog("Parse $_[0] failed!");
	return (undef,undef);
}

sub GEN_PKGLIST2 {
	syncUserCache();

	chdir $CACHEDIR or EXIT("$! chdir $CACHEDIR (GEN_PKGLIST)");
	
	foreach my $f ($CACHEPKGS,"$CACHEPKGS.bz2", "$CACHEPKGS.gz") {
		rx("unlink $f") if (-f $f);
	}
	closeAptPkgCache();
	open PA, "> $MCACHEPKGS" ||EXIT("$! open > $MCACHEPKGS\n");
	info(-1,"Generating $MCACHEPKGS\... \n");
	foreach my $s (<*>) {
		chomp $s;
		next unless (-l $s || -d $s);
		next if (-l $s && checkSymlink($s)==1);
		unless ($s eq 'IMPORTED') {
			my $pf = namePrefix($s);
			if ($pf ne $s){
				unless (-d $pf){
					sys("mkdir -m 0755 -p $pf") == 0
					||EXIT("$! mkdir $pf");
				}
				sys("mv $s $pf") == 0||EXIT("$! mv $s $pf");
				next;
			}
		}
		foreach my $p (<$s/*>){
			next if (-l $p && checkSymlink($p)==1);
			$p = basename($p);
			SCAN (<$s/$p/*.deb>) if ($opts{'rescan-all'} && -w "$s/$p");
			foreach my $di (reverse sort (<$s/$p/*>)){
				chomp $di;
				next unless ($di =~/Packages/);
				info(2,"reading $CACHEDIR/$s/$p/$di");
				my (@commit,$pkg,$ver,$fn);
				my $FH = zOpen($di);
				foreach my $l (<$FH>) {
					if ($l =~ /^Package:\s*(\S+)/){
						$pkg = $1;
					} elsif ($l =~ /^Version:\s*(\S+)/){
						$ver = $1;
					} elsif ($l =~ /^Filename:\s*(\S+)/){
						$fn = "$s/$p/$1";
						$l = "Filename: $fn\n";
					} elsif($l=~ /^Architecture:\s*(\S+)/){
					# non-Debian x86 arch hack to i386
						if (my $t = $XARCH{$1}) {
							$l = "Architecture: $t\n";
						}
					}
					push @commit, $l;
				}
				close $FH;
				if (exists $LCACHE->{$pkg}){
					wLog("Package: $pkg already exists in ",
					"$MCACHEPKGS, skipped");
				} elsif (exists $LCACHE->{$pkg}->{$ver}){
					wLog("Package: $pkg ($ver) already ",
					"exists in $MCACHEPKGS, skipped");
				} else {
					$LCACHE->{$pkg}->{$ver}->{'Package'} 
					= $pkg;
					
					$LCACHE->{$pkg}->{$ver}->{'Version'} 
					= $ver;
					
					$LCACHE->{$pkg}->{$ver}->{'Filename'} 
					= $fn;
					print PA @commit;
				}
			}
		}
	}
	close PA;
	
	if (genRelease($MRELEASE) == 1 ){
		my $arl = &localListName;
		$arl =~ s/_Packages$/_Release/;
		unless (rx("cp $MRELEASE $arl") == 0) {
			EXIT("$!: $ROOTX cp $MRELEASE $arl\n");
		}
	}

	if (($MYCACHE ne $CACHEDIR) && (-r $MCACHEPKGS)) {
		rx("cp $MCACHEPKGS $CACHEPKGS");
		rx("cp $MRELEASE $RELEASE");
		compress($MCACHEPKGS);
	}
		
	my $apl = &localListName;
	info(-1,"Updating $apl");
	unless (rx("cp $CACHEPKGS $apl") == 0) {
		EXIT("$!: $ROOTX cp $CACHEPKGS $apl\n");
	}

	if ($MYCACHE ne $CACHEDIR) {
		rx("$DZ $CACHEPKGS");
	} else { 
		compress("$CACHEPKGS");
	}
	
	info(-1,"Done generating $CACHEPKGS\n");
	# the quick version of apt-get update, only updates the modified file.
	
	my $sl = $DIR.$_config->get('Dir::Etc').'/'
	.$_config->get('Dir::Etc::sourcelist');
	
	return 0 if ( sourcesEd($sl) == 0 );
	
	UPDATE() == 0 || EXIT("$! apt-get update");
}


sub findSrcDir {
	my $dir = shift;
	chdir $dir || EXIT("$! chdir $dir (FindSrcDir)");
	my $ret;
	open FH, "find -name rules |"|| EXIT("$! unable to open find");
	while(<FH>){
		chomp;
		next unless (/debian\/rules$/);
		if (/..\/debian\/rules$/) {
			my $d = dirname $_;
			$d = dirname $d;
			chdir $d || EXIT("$! chdir $d (find srcDir) ");
		}
		if (-x 'debian/rules'){
			my $d = cwd;
			push @$ret, $d;
		}
		chdir $dir || EXIT("$! chdir $dir (FindSrcDir)");
	}
	close FH;
	return $ret;
}

sub findDEBDir {
	my $dir = shift;
	chdir $dir || EXIT("$! chdir $dir (FindDEBDir)");
	my $ret;
	open FH, "find -name DEB -type d |"|| EXIT("$! unable to open find");
	while(<FH>){
		chomp;
		push @$ret, $_;
	}
	close FH;
	return $ret;
}


sub CLEANDEBS {
	my $dir = shift || $BUILDDIR;
	info(0,"Cleaning debs in $dir\n");
	my $dirs = findDEBDir($dir);
	foreach my $d (@$dirs){ 
		chdir $d || EXIT ("$! chdir $d CLEANDEBS");
		my $latest = (-l 'latest') ? basename(readlink('latest')) : '';
		foreach my $dd (<*>) {
			if ($latest && (($latest eq $dd)||($dd eq 'latest'))){
				next;
			} 
			if ($opts{'failed-only'}){
				chomp(my $poo = `find $dd -name "*.deb"`);
				if ($poo =~/\S/) {
					next;
				}
			}
			if ($opts{'simulate'}){
				info(0,"rm -rf $dd (sim) in: ",cwd);
			} else {
				info(0,"rm -rf $dd in:", cwd);
				sys("rm -rf $dd");
			}
		}
		chdir $dir || EXIT ("$! chdir $dir CLEANDEBS");
	}
}

sub CLEANSD {
	# does debclean but w/o checking for Build-Dependencies
	my $dir = shift || $BUILDDIR;
	info(-1,"Cleaning source directories in $dir/");
	my $dirs = findSrcDir($dir);
	foreach my $d (@$dirs){
		chdir $d || EXIT("$! chdir $d (CLEANSOURCEDIR)");
		if  ($opts{'simulate'}) {
			info(0,"$d\: `$FAKER debian/rules clean");
		} else {
			if (sys("$FAKER debian/rules clean")){
				wLog("CLEAN error $? $! in ",cwd);
			}
		}
		chdir $dir || EXIT("$! chdir $dir (CLEANSOURCEDIR)");
	}
}

sub PURGESD {
	my $dir = shift || $BUILDDIR;
	my $dirs = findSrcDir($dir);
	info(-1,"Purging source directories in $dir/");
	my @rmd;
	foreach my $d (@$dirs){
		push @rmd, $d if ((-l $d) || (-d $d));
	}
	chdir $dir;
	if  ($opts{'simulate'}) {
		foreach (@rmd) { info(0,"rm -rf $_") }
	} else {
		if (sys("rm","-rf",@rmd)){
			wLog("PURGE error $? $! in",join(' ',@rmd));
		}
	}
}

# make the version dependencies a little more lax for packages
# in the same source version
sub fixDepVersions {
	foreach my $f (@_) {
		next unless ($f =~/\.deb$/);
		my $owd = cwd;
		chdir dirname($f) || EXIT("$! chdir ",dirname($f));
		$f = basename($f);
		my ($v,$sv,$mod,$ar);
		open FH, "$DPKGDEB -f $f |" or EXIT("$! $? $DPKGDEB -f $f");
		while(<FH>){
			if (/^Version:\s+(\S+)/) {
				$v = $1;
				$sv = $v;
				lvchomp($sv);
			} elsif ($v && $sv && ($v ne $sv)) {
				if (/\(\s*\=\s*$sv\s*\)/){
					$mod |= 1;
				} elsif (/\(\s*\<\=\s*$sv\s*\)/){
					$mod |= 2;
				} elsif (/\(\s*\>\=\s*$v\s*\)/){
					$mod |= 4;
				} elsif (/^Provides\:/ && /\Q$sv\E(\S*)/){
					$mod |= 8;
				} elsif (/\(\s*\=\s*$v\s*\)/){
					$mod |= 0x20;
				}
			} 
			if (/^Architecture\:\s*(\S+)/){
				$ar = $1;
				if (defined $XARCH{$ar} &&
				($XARCH{$ar} ne $ar)){
					$mod |= 0x10;
				}
			}
		}
		close FH;
		if ($mod) {
			my $oldmask = umask 0022;
			my $dir = $f;
			$dir =~s/\.deb$//;
			sys("$FAKER mkdir -p -m 0755 $dir/DEBIAN") == 0 
			|| EXIT("$! $? mkdir -p -m 0755 $dir/DEBIAN");
			
			sys("$FAKER chmod --recursive -st $dir") == 0
			|| EXIT("$! $? chmod --recursive -st $dir");
			
			sys("$FAKER $DPKGDEB -x $f $dir") == 0 
			|| EXIT("$! $? $DPKGDEB -x $f $dir");

			sys("$FAKER $DPKGDEB -e $f $dir/DEBIAN") == 0
			|| EXIT("$! $? $DPKGDEB -e $f $dir/DEBIAN");

			open FH, "$dir/DEBIAN/control" 
			|| EXIT("$! $? < $dir/DEBIAN/control");
			
			open FD, "> $dir/DEBIAN/control.new" 
			|| EXIT("$! $? > $dir/DEBIAN/control.new");
			
			while (<FH>){
				if (($mod & 1) 
				&& s/(\(\s*)\=(\s*$sv\s*\))/$1\>\=$2/g){
					info(0,"$f\: replacing (= $sv) with (>= $sv)");
				} 
				if (($mod & 2) 
				&& s/(\(\s*\<\=\s*)$sv(\s*\))/$1$v$2/g){
					info(0,"$f\: replacing (<= $sv) with (<= $v)");
				}
				if (($mod & 4)
				&& s/(\(\s*\>\=\s*)$v(\s*\))/$1$sv$2/g){
					info(0,"$f\: replacing (>= $v) with (>= $sv)");
				}
				if (($mod & 8) && /^Provides/ 
				&& s/$sv\S*/$v/g){
					info(0,"$f\: fixing Provides: $sv/$v in packagename");
				}
				if (($mod & 0x10) && $ar 
				&& (defined $XARCH{$ar})
				&& s/^(Architecture:)\s*$ar/$1 $XARCH{$ar}/){
					info(0,"$f\: replacing Architecture: $ar with $XARCH{$ar}");
				}
				if (($mod & 0x20)
				&& s/(\(\s*)\=(\s*)$v(\s*\))/$1\>\=$2$sv$3/g){
					info(0,"$f\: replacing (= $v) with (>= $sv)");
				} 
				print FD $_;
			}
			close FD;
			close FH;
			
			unlink "$dir/DEBIAN/control"
			|| EXIT("$! $? unlink $dir/DEBIAN/control");

			rename "$dir/DEBIAN/control.new","$dir/DEBIAN/control"
			|| EXIT("$! $? rename control.new control ($dir)");
			
			sys("$FAKER $DPKGDEB -b $dir $f")==0
			||EXIT("$DPKGDEB -b $dir $f");

			sys("rm -rf $dir") == 0 ||EXIT("$! $? rm -rf $dir");
			umask $oldmask;
		}
		chdir $owd || EXIT("$! $? chdir $owd");
	}
}

# only works on files in ONE dir
sub SCAN {
	my (@files) = @_;
	return unless (@files);
	my $plist = dirname($files[0]).'/Packages';
	my $ret;
	my $com;
	for my $F (reverse sort @files) {
		$F =~s#//#/#g;
		unless (-r $F) {
			wLog("$F not readable!");
			next;
		}
		open FH, "$DPKGDEB -f $F |" or EXIT("$!: $DPKGDEB -f $F\n");
		my ($extra,$pkg,$v) = (0,'',$verDefault);
		my @commit;
		while (<FH>){
			if (/^Package:\s+(\S+)/){
				$pkg = $1;
			} elsif (/^Version:\s+(\S+)/){
				$v = $1;	
			} elsif (/^Description:/) {
				push (@commit, extras($F)) if ($extra == 0);
				$extra = 1;
			}
			push @commit, $_;
		}
		close FH;
		extras($F) if ($extra == 0);
		if (defined $ret->{$pkg}){
			wLog("Package: $pkg exists multiple times in $plist");
			if ($VS->compare($ret->{$pkg},$v) > 0 ){
				wLog("Version: $ret->{$pkg} used. ",
				"Version: $v ignored");
				next;
			} else {
				wLog("Version: $v used. ",
				"Version: $ret->{$pkg} will be ignored");
			}
		}
		$ret->{$pkg} = $v;
		@{$com->{$pkg}} = (@commit,"\n");
	}
	open IN, "> $plist" or EXIT("$!: $plist in ", cwd);
	foreach my $pkg (sort keys %$com){
		print IN @{$com->{$pkg}};
	}
	close IN;
	compress($plist);

	sub extras {
		my $F = shift;
		my $fn = basename($F);
		my @ret;
		#only the basename here, add path when making Packages.(gz|bz2)
		push @ret, "Filename: $fn\n";
		my @stat = stat($F) or EXIT("$! stat $F");
		push @ret, "Size: $stat[7]\n";
		my $md5 = md5sum($F);
		push @ret, "MD5sum: $md5\n";
		return @ret;
	}
	return $ret;
}

1;
