sub initAptPkgCache {
	unless ($CACHE){
#		undef $PCACHE;
		closeAptPkgCache();	
	 	&ACHECK;
		$CACHE = 1;
	}
}

sub closeAptPkgCache {
	foreach my $x ($PCACHE,$SCACHE,$CACHE,$LCACHE,$DEPCACHE){
		if (keys %$x){
			foreach my $one (keys %$x) {
				if (keys %{$x->{$one}}){
					foreach my $two (keys %{$x->{$one}}){
						undef  $x->{$one}->{$two};
					}
				}
				undef  $x->{$one};
			}
		}
		undef  $x;
	}
	undef $PCACHE;
	undef $SCACHE;
	undef $CACHE;
	undef $LCACHE;
	undef $DEPCACHE;
}

sub P_archIndep2 {
	if ($opts{'source-only'}){
		info(-1,"WARNING: Source only option selected");
		return 1;
	}
	my ($pkg,$ver) = @_;
	show2Cache($pkg);
	if (my $arch = $PCACHE->{$pkg}->{$ver}->{'Architecture'}) {
		if ($arch eq 'all' || $arch eq 'any' ) {
			return 0;
		}
	}
	return 1;
}

sub P_isInstallable {
	my ($pkg,$ver) = @_;
	show2Cache($pkg) unless ($PCACHE->{$pkg}->{'Cached'});
	return 0 if ($PCACHE->{$pkg} && $PCACHE->{$pkg}->{$ver} &&
	$PCACHE->{$pkg}->{$ver}->{'Filename'});
	iLog("PKG $pkg/$ver is not installable!");
	return 1;
}

sub P_verNewest {
	my $pkg = shift;
	my $ret = $verDefault;
	show2Cache($pkg);
	foreach my $v (keys %{$PCACHE->{$pkg}}) {
		next if (defined $CacheField{$v});
		if ($VS->compare($v,$ret) > 0){
			$ret = $v;
		}
	}
	return $ret;
}

sub P_getPkgField {
	my ($pkg,$ver,$field) = @_;
	show2Cache($pkg);
	my $ret;
	if ( $PCACHE->{$pkg} && $PCACHE->{$pkg}->{$ver} &&
	(my $F = $PCACHE->{$pkg}->{$ver}->{$field})) {
		foreach my $p (split /\s*,\s*/, $F){
	#		if (my $r = resolveDep($p,0)){
			$ret->{$p} = 0;
	#		}
		}
	}
	return $ret;
}

sub isInstalled {
	my $pkg = shift;
	cacheStatus();
	return 0 if (defined $PCACHE->{$pkg}->{'CurrentVer'});
	return 1;
}

sub isVInstalled {
	my ($pkg,$ver) = @_;
	cacheStatus();
	if ((defined $PCACHE->{$pkg}->{'CurrentVer'}) &&
	($PCACHE->{$pkg}->{'CurrentVer'} eq $ver)){
		return 0;
	}
	return 1;
}

sub isAvailable {
	my ($pkg,$ver) = @_;
	show2Cache($pkg);	
	if (defined $PCACHE->{$pkg}->{$ver}) {
	#	print "FFF $pkg,$ver is available\n" if ($pkg =~/perl/);
		return 0;
	}
	return 1;
}

sub currentVer {
	my $pkg = shift;
	cacheStatus();
	if ($PCACHE->{$pkg}->{'CurrentVer'}){
		return $PCACHE->{$pkg}->{'CurrentVer'}
	}
	return $verDefault;
}

sub getVirtuals {
	my $pkg = shift;
	&initAptPkgCache;
	my $ret;
	if ($PCACHE->{$pkg}->{'ProvidesList'}) {
		return $PCACHE->{$pkg}->{'ProvidesList'};
	}
	
	my $in = 0;
	#dbg(0x400,"getVirtuals($pkg)\n");
	open FH,"$APTCACHE showpkg $pkg 2>/dev/null|" 
	|| EXIT("$! getVirtuals)\n");
	
	my $i = 1;
	while (<FH>) {
		if (/^Reverse Provides:/) {
			$in = 1;
		} elsif ($in && /^[A-Z][^:]+:/) {
			$in = 0;
			last;
		} elsif ($in && /^(\S+)\s+(\S+)/) {
			$ret->{$i}->{'P'} = $1;
			$ret->{$i}->{'V'} = $2;
			++$i;
		}
	}
	close FH;
	$PCACHE->{$pkg}->{'ProvidesList'} = $ret;
	return $ret;
}

sub P_getSection {
	my ($pkg,$ver) = @_;
	show2Cache($pkg);
	if ($PCACHE->{$pkg}->{$ver}->{'Section'}) {
		return	$PCACHE->{$pkg}->{$ver}->{'Section'};
	}
	return 'unknown';
}

sub getRevDeps {
	my ($pkg) = @_;
	$pkg =~s/=\S+$//;
	# pkg is the package we're analyzing
	# parent is the package that originally depended on pkg
	if (defined $PCACHE->{$pkg}->{'RevDependsList'}) {
		return $PCACHE->{$pkg}->{'RevDependsList'};
	}
	my $ret;
	$ret->{$pkg} = 1;
	my $in = 0;
	
	open FH,"$APTCACHE showpkg $pkg 2>/dev/null|"
	||EXIT("$!getRevDeps($pkg)\n");
	while (<FH>) {
		if (/^Reverse Depends:/) {
			$in = 1;
		} elsif ($in && /^\s+([^,]+)/) {
			$ret->{$1} = 1 if (isInstalled($1) == 0);	
		} elsif ($in && /^\S/) {
			close FH;
			last;
		}
	}
	close FH;
	$PCACHE->{$pkg}->{'RevDependsList'} = $ret;
	return $ret;
}


# aptGetID (Install Dependencies)
# install Installation Dependencies 
# (Depends Pre-Depends Suggests Recommends Conflicts Replaces Obsoletes)
sub aptGetID {
	my ($pkg,$ver) = @_;
	if ($PCACHE->{$pkg}->{$ver}->{'InstallDepends'}) {
		return $PCACHE->{$pkg}->{$ver}->{'InstallDepends'};
	}
	show2Cache($pkg);
	my $ret;
	my $last;

	foreach my $f (keys %{$PCACHE->{$pkg}->{$ver}}){
		next unless (defined $Ab{$f});
		foreach my $r (split(/\s*,\s*/,$PCACHE->{$pkg}->{$ver}->{$f})){
			mchomp($r);
			$ret->{$r} = 1 if ($r);
		}
	}
	$PCACHE->{$pkg}->{$ver}->{'InstallDepends'} = $ret;
	return $ret;
}

sub cacheStatus { 
	return if ($PCACHE->{'CachedStatus'});
	my ($fh,$f);
	$f = {
		'Package' => 1,
		'Version' => 1,
		'Source' => 1,
		'Status' => 1,
		'Provides' => 1,
#		'Replaces' => 1,
	};
	undef %ALT; # the great hash of virtual package resolution
	$fh = zOpen($STATUS);
	$PCACHE = ctrl2Href($fh,$PCACHE,$f,'Status');
	$PCACHE->{'CachedStatus'} = 1;
	# the immutable cache
	# once set, this stays on and read-only throughout
	$IMCACHE->{'Cached'} = 1;
}

# the following functions only appear when NOT using libapt-pkg-perl
# for package cache and versioning access: 

sub show2Cache {
	my $p = shift;
	$p =~ s/\=\S+//g;
	$p =~ s/[^\w\d\+\.\-\s]+//g;
	return 0 if ($PCACHE->{$p}->{'Cached'});
	&initAptPkgCache;
	my ($fh,$f);
	open ($fh,"$APTCACHE show $p 2>/dev/null |") || EXIT("$!: show $p\n");
	$PCACHE = ctrl2Href($fh,$PCACHE,$fP,'Package');
	$PCACHE->{$p}->{'Cached'} = 1;
}

# XXX note to self: gradually migrate to this one over the non-M version
sub show2CacheM {
	my $ops = shift;
	my $ps;
	foreach my $p (keys %$ops){
	#	$p =~ s/\=\S+//g;
		($p) = ($p =~ /^\s*([\w\d\+\.\-\s]+)/);
		
		$ps->{$p} = 1 unless (exists $PCACHE->{$p} 
		&& $PCACHE->{$p}->{'Cached'});
	}
	my $arg = join(' ',keys %$ps);
	return unless ($arg);
	&initAptPkgCache;
	my $fh;
	#print "AC show $arg\n" if ($arg=~/\S+\s+\S+/);
	open($fh,"$APTCACHE show $arg 2>/dev/null|") || EXIT("$!: showM $arg");
	$PCACHE = ctrl2Href($fh,$PCACHE,$fP,'Package');
#	foreach my $p (keys %$ps) {$PCACHE->{$p}->{'Cached'} = 1;}
}

# puts stuff into areas of $PCACHE/$SCACHE 
sub ctrl2Href {
	my ($FH,$c,$f,$idx) = @_;
	my ($tmp,$last);
	while (<$FH>) {
		if (/^$/) {
			if (defined $tmp){
		 		$c = commit2Cache($idx,$tmp,$c,$FH);
				if ($idx eq 'control') {
					close $FH;
					return $c;
				}
			}
			undef $last;
			undef $tmp;
		} elsif (/^([A-Z\-]+):/i) {
			my $k = $1;
			$k =~ s/(\b)(\w)/$1\u$2/g;
			undef $last;
			if (defined $f->{$k}){
				my ($value) = ($_ =~ /:\s+(.*)$/);
				mchomp($value);
				$tmp->{$k} = $value;
				$last = $k;
			}
		} elsif ($last && /^\s+\w/) {
			my $value = $_;
			mchomp($value);
			$tmp->{$last} .= " $value";
		} else {
			undef $last;
		}
	}
	if (defined $tmp) {
		 $c = commit2Cache($idx,$tmp,$c,$FH,$p);
	}
	close $FH;
	return $c;

	sub commit2Cache {
		my ($index,$tc,$cc,$fh) = @_;
		if ($index ne 'Status' && $tc->{'Version'}) {
			unless ($cc->{$tc->{$index}} &&
			$cc->{$tc->{$index}}->{$tc->{'Version'}} &&
			$cc->{$tc->{$index}}->{$tc->{'Version'}}->{'Filename'}){
				$cc->{$tc->{$index}}->{$tc->{'Version'}}=$tc;
			}
			if ($index eq 'Package'){
				$cc->{$tc->{$index}}->{'Cached'} = 1;
			}
			if (my $bins = $tc->{'Binary'}){
			# these only appear for source packages
				foreach my $bb (split(/\s*,\s*/,$bins)){
					$cc->{$bb}->{'Cached'} = 1;
				}
			}
		} elsif ($index eq 'control'){
			return $tc;
		} elsif ($index eq 'Status') {
			$cc = commitStatus($tc,$cc);
		}
		return $cc;
	}
	
	sub commitStatus {
		my ($t,$C) = @_;
		return $C unless ($t->{'Status'});
		unless( ($t->{'Status'} =~/not-installed/)
		|| ($t->{'Status'} =~/config-files/)) {
			$C->{$t->{'Package'}}->{'CurrentVer'} = $t->{'Version'};
			$C->{$t->{'Package'}}->{'CurrentSrc'} 
			= $t->{'Source'} if ($t->{'Source'});
			foreach my $f ('Provides'){
				next unless ($t->{$f});
				foreach(split(/\s*,\s*/,$t->{$f})){
					# dont worry about duplicate stuff
					# for virtual package 
					# dependency resolution, as long
					# as we have it installed its OK.
					$ALT{$_} = $t->{'Package'} unless ($ALT{$_});
				}
			}
		}
		# only set once, and keep it read-only here in cacheStatus
		unless ($IMCACHE->{'Cached'}){
			$IMCACHE->{$t->{'Package'}} = $t->{'Status'};
		}
		return $C;
	}
}

1;
