
sub policy2CacheM {
	my $ops = shift;
	my $ps;
	foreach my $p (keys %$ops){
		#$p =~ s/\=\S+//g;
		#$p =~ s/[^\w\d\+\.\-\s]+//g;
		($p) = ($p =~ /^\s*([\w\d\+\.\-\s]+)/);
		$ps->{$p} = 1 unless (exists $PCACHE->{$p} 
		&& exists $PCACHE->{$p}->{'PolicyVer'});
	}
	my $arg = join(' ',keys %$ps);
	return unless ($arg);
	
	&initAptPkgCache;
	#print "AC policy $arg\n" if ($arg =~/\S+\s+\S+/);
	open PIPE, "$APTCACHE policy $arg 2>/dev/null |" 
	or EXIT("$!:\`$APTCACHE policy $arg\`\n");
	my $p;
	while (<PIPE>) {
		if (/^([\w\d\+\.\-]+)\:/){
			$p = $1;
		} elsif (/^\s+Candidate:\s*([\d\.\+\-\w\:]+)\s*\n/) {
			$PCACHE->{$p}->{'PolicyVer'} = $1 if ($p);
			undef $p;
		}
	}
	close PIPE;
	foreach my $p (keys %$ps){
		unless ($PCACHE->{$p} && $PCACHE->{$p}->{'PolicyVer'}) {
			# let the higher level functions deal with it
			$PCACHE->{$p}->{'PolicyVer'} = $verDefault;
		}
	}
	show2CacheM($ps);
	showsrc2CacheM($ps);
}

sub P_verDefault {
	my $p = shift;
	mchomp($p);
	my $ret = $verDefault;
	unless ($PCACHE->{$p}->{'PolicyVer'}) {
		my $ps;
		$ps->{$p} = 0;
		policy2CacheM($ps);
	}
	$ret = $PCACHE->{$p}->{'PolicyVer'};
	&initAptPkgCache;
	# odd case:
	# xlibs from Experimental is installed
	# xlibs-dev equal to version of xlibs _needs_ to be installed
	# but defaults to the default (non-Experimental) version
	# only for '=' dependencies
	# Unstable and below never depends on Experimental, only vice-versa
	show2Cache($p);
	foreach my $F ('Pre-Depends','Depends') {
		if (my $f = $PCACHE->{$p}->{$ret}->{$F}) {
			foreach my $d (split /\s*,\s*/, $f) {
				if ($d =~ /\(/ 	&&
				(($d =~/[^\>\<]\=[^\>\<]/)||($d !~/[\=\<\>]/))){
					if ($d =~ /\|/) {
	foreach my $l (split(/\s*\|\s*/,$d)){
		$ret = cmpSwap($l,$p,$F,$ret);
	}
					} else {
	$ret = cmpSwap($_,$p,$F,$ret);
					}
				}
			}
		}
	}
	mchomp($ret);
	#dbg(0x40,"P_verDefault($p) == $ret");
	return $ret;

	sub cmpSwap {
		my ($l,$p,$F,$ret) = @_;
		mchomp($l);
		return $ret unless ($l);
		my ($pkg,$expr,$ver) = ($l =~
		/^([\d\w\-\.\+]+)\s*\(\s*([\=\<\>]*?)\s*([\.\d\+\-\w\:]+?)\)/x);
		
		return $ret unless ($pkg);
		if ($p eq $pkg) {
			wLog("[!!] $p $F on itself: $l, skipped");
			return $ret;
		}
		if (isInstalled($pkg) ==0 ) {
			return (currentVer($pkg));
		}
		my $nv = P_verDefault($pkg);
		
		if ( (!(defined $expr) || ($expr eq '=')) && ($ver ne $nv) ){
			wLog("Package: $p Version: $nv selected over $ret");
			return $nv if (defined $PCACHE->{$p}->{$nv});
		}
		return $ret;
	}
}

# picks version(s) for each argument called
sub S_pickVers {
	my $ret; 
	my $tmp = map {$_ => 1} @_;
	showsrc2CacheM($tmp);
	foreach my $pkg (@_) {
		if (defined $ret->{$pkg}) {
			next;
		}
		if ($pkg =~/(.+)=(.+)/) {
			my ($src,$ver) = S_verSelect($1,$2);
			if ($src && ($ver ne $verDefault)) {
				$ret->{$src}->{$ver}->{'Z'} = 1;
			}
			unless ( $ret->{$src}->{$ver}->{'Z'}){
				wLog("$src [$ver] not available\n");
			}
			next;
		}	
		my ($src,$ver) = S_verSelect($pkg,'default');
		unless ($src && $ver ne $verDefault){ 
			wLog("Source for package ($pkg) unavailable. Skipped.");
			next;
		}
		if ( !$opts{'newest-versions'} 
		&& !$opts{'all-versions'}
		&& !$prompt{'source'} ){
		#which means default version, *could* be newest
			if ($src && ($ver ne $verDefault)) {
				$ret->{$src}->{$ver}->{'Z'} = 1;
			} else { 
				wLog("$src [$ver] not available!\n");
			}
			next;
		}			
		my $vers;
		($pkg,$vers) = bin2srcV($pkg,$vers);
		if ($opts{'all-versions'}) {
			foreach my $p (keys %$vers) {
				foreach my $v (keys %{$vers->{$p}}) {
					$ret->{$p}->{$v}->{'Z'} = 1;
				}
			}
			next;
		} 
	
		# prompt the user to pick available versions
		my $count = 0;
		my $newest = $verDefault;
		foreach my $p (keys %$vers) {
#		print "HERE $p\n";
			foreach my $v (sort {$VS->compare($b,$a)}
			keys %{$vers->{$p}}) {
				$newest = $v if ($newest eq $verDefault);
				++$count;
			}
		}
		if ( $prompt{'source'} && ($count > 1) ) {
			my $i = 1;
			my $sel;
			print "Available source packages of $pkg\:\n";
			my $dnum = '';
			foreach my $p (keys %$vers) {
				foreach my $v (sort {$VS->compare($b,$a)} 
				keys %{$vers->{$p}}) {
					print "\t$i. $p ($v)\n";
					$sel->{$i}->{'P'} = $p;
					$sel->{$i}->{'V'} = $v;
					if ($v eq $ver) {
						$dnum="$i. $p ($v)";
					}
					++$i;
				}
			}
			$dnum = $dnum ? $dnum : $newest;
			print "Select one or more. [default=$dnum]: ";
			mchomp (my $pick = <STDIN>);
			foreach my $i (split /\D+/,$pick) {
				if (defined $sel->{$i}) {
					$ret->{$sel->{$i}->{'P'}}->
						{$sel->{$i}->{'V'}}->{'Z'} = 1;
				} else { 
					print(
					"Invalid selection for $pkg ($i)\n");
				}
			}
		} 
		foreach my $p (keys %$vers) {
			unless (defined $ret->{$p}) {
				$ret->{$p}->{$newest}->{'Z'} = 1;
			}
		}
	}
	return ($ret);
}


1;
