# various simple file-creation routines go here

sub genBashRC {
	my $rc = shift;
	open FD, "> $rc" or EXIT("> $rc");
	print FD <<EOF;
if [ "\$PS1" ]; then
	if [ -f ~/.bashrc ]; then
		source ~/.bashrc
	fi
	apt-fu help-disclaimer	

	PS1=\'APT-Fu:\\w\\\$ \'
fi

EOF
	close FD;
}

sub genRelease {
	my $rel = shift;
	return 0 if (-r $rel);
	open FF, "> $rel" or EXIT("$! Failed to open $rel\n");
	print FF <<EOF;
Archive: apt-fu
Component: main
Origin: localhost
Label: apt-fu
Architecture: $XARCH{$ENV{'MY_DEBIAN_ARCH'}}
EOF
	close FF;
	
	wLog("A Release file has been created at $rel. ",
	" Edit and modify if needed\n");
	# if changed, signal that a copy of the Release file is needed to
	# /var/lib/apt/lists
	return 1;
}


sub sourcesEd {
	my $slist = shift;
	$slist =~s#//#/#g;

	open FH, "< $slist"  or EXIT("$! error opening $slist!\n");
	while (<FH>) {
		if (/^\s*deb\s+/ && /\Q$CACHEDIR\E /) {
			close FH;
			return 0;
		}
	}
	close FH;
	print "APT source URI for [ $CACHEDIR ] not found in $slist.\nAdd ",
	"this line to $slist now? [Y/n]: ";
	mchomp(my $d = <STDIN>);
	$d = lc $d;
	if ($d ne 'n'){
		info(-1,"Writing APT URI entry to $slist, backed up to ",
		"$TMPDIR/sources.list.apt-fu.old\n");
		
		my $wf = "$TMPDIR/sources.list.apt-fu";

		sys("cp $slist $wf.old") == 0 || EXIT("$! cp $slist $wf.old");
		sys("cp $slist $wf")== 0 || EXIT("$! cp $slist $wf");
		open FH, "> $wf" or EXIT("$! error opening $wf\n");
		print FH "deb file:$CACHEDIR ./ \n";
		
		open FD, "$wf.old" or EXIT("$! error opening $wf.old");
		while (<FD>) {
			print FH $_;
		}
		close FD;
	
		close FH;
		info(0,"$ROOTX mv $wf $slist\n");
		sys("$ROOTX mv $wf $slist")==0 || EXIT("$! mv $wf $slist");
		return 1;
	}
	return 0;
}



1;

